local _Questic = _Questic_ADDON_Globals;

local function FormatMoney(Money,Short)
	local gold = floor(Money/10000)
	local silver = floor(Money/100) - gold*100;
	local copper = Money - silver*100 - gold*10000;
	local MoneyString = "";
	if gold > 0 then 
		MoneyString = gold.."|cFFFFD700g|r"; 
	end 
	if silver > 0 or (gold > 0 and not Short) then 
		MoneyString = MoneyString.." "..silver.."|cFFC0C0C0s|r"
		
	end 
	if copper > 0 or (gold > 0 and not Short) or (silver > 0 and not Short) then 
		MoneyString = MoneyString.." "..copper.."|cFFb87333c|r";
	end 
	return MoneyString
end 

_Questic.ItemSelectButton_OnShow = function(self)
	if self.ItemType == "preview" then 
		local Name,_,_,_,_,_,_,QuestCount = GetItemInfo(self.ItemIndex);
		local Texture = GetItemIcon(self.ItemIndex);
		self.Texture:SetTexture(Texture);
		if QuestCount and QuestCount > 1 then
			self.Text:SetText(QuestCount);
		else
			self.Text:SetText("");
		end	
	elseif self.ItemType == "money" then 
		self.Texture:SetTexture(133784);
		self.Text:SetText(FormatMoney(self.ItemIndex,true));
	else 
		if GetQuestItemInfo(self.ItemType,self.ItemIndex) ~= "" then 
			local Name,Texture,QuestCount = GetQuestItemInfo(self.ItemType,self.ItemIndex);
			self.Texture:SetTexture(Texture);
			if QuestCount and QuestCount > 1 then
				self.Text:SetText(QuestCount);
			else
				self.Text:SetText("");
			end
		elseif GetQuestCurrencyInfo(self.ItemType,self.ItemIndex) ~= "" then 
			local Name,Texture,QuestCount = GetQuestCurrencyInfo(self.ItemType,self.ItemIndex);
			self.Texture:SetTexture(Texture);
			if QuestCount and QuestCount > 1 then
				self.Text:SetText(QuestCount);
			else
				self.Text:SetText("");
			end
		end 
	end 
	local Font,_,Flag = self.Text:GetFont()
	self.Text:SetFont(Font,20,Flag);
	for i = 1,15 do 
		local Width = self.Text:GetStringWidth();
		if Width > self:GetWidth() then 
			self.Text:SetFont(Font,20 - i,Flag);			
		else 
			break; 
		end 
	end 
end 

_Questic.ItemSelectButton_OnEnter_OnLeave = function(self,Enter)
	if Enter then 
		if self.ItemIndex and self.ItemType then
			if self.ItemSubType == "item" and GetQuestItemInfo(self.ItemType,self.ItemIndex) and GetQuestItemInfo(self.ItemType,self.ItemIndex) ~= "" then 
				Questic_Tooltip:SetOwner(self, "ANCHOR_RIGHT");
				Questic_Tooltip:SetQuestItem(self.ItemType, self.ItemIndex);
			elseif self.ItemSubType == "currency" then 
				Questic_Tooltip:SetOwner(self, "ANCHOR_RIGHT");
				Questic_Tooltip:SetQuestCurrency(self.ItemType,self.ItemIndex);
			elseif self.ItemSubType == "preview" then 
				Questic_Tooltip:SetOwner(self, "ANCHOR_RIGHT");
				Questic_Tooltip:SetHyperlink(self.ItemIndex);	
			elseif self.ItemSubType == "money" then 
				Questic_Tooltip:SetOwner(self, "ANCHOR_RIGHT");
				Questic_Tooltip:SetText("Required gold to complete quest:\n"..FormatMoney(self.ItemIndex),1,1,1);					
			end 
		end
	else 
		Questic_Tooltip:Hide();
	end 
	_Questic_ADDON_Globals.HighlightBorder(self,false);
end

_Questic.ItemSelectButton_OnMouseUp_OnMouseDown = function(self,Down)
	_Questic_ADDON_Globals.HighlightBorder(self,Down);
	if self.ItemType == "choice" and not Down then 
		if type(self.OnClick) == "function" then
			self.OnClick(self);
		end
		if Questic_ADDON_ItemSelectMainFrame then
			Questic_ADDON_ItemSelectMainFrame:UpdateItemSelect()
		end
	end
end 
