local _Questic = _Questic_ADDON_Globals; 
_Questic.GossipFunctions = {};

local GossipFuncs = _Questic.GossipFunctions;

--local ActivGossipList = {};

local function MatchStrings(a,b)
	local Plaina = strtrim(a:lower());
	local Plainb = strtrim(b:lower()); 
	
	if Plaina == Plainb then 
		return true; 
	else
		local Lettersb = gsub(Plainb,"%A","")
	
		local WordsIna = {strsplit(" ",Plaina)};
		local WordsInb = {strsplit(" ",Plainb)};
		
		local WordsMatched = 0
		for i,v in ipairs(WordsIna) do 
			if Lettersb:find(gsub(v,"%A","")) then 
				WordsMatched = WordsMatched + 1; 
			end 
		end 
		
		local MaxWords = #WordsIna > #WordsInb and #WordsIna or #WordsInb;
		
		local MatchPercentage = WordsMatched/MaxWords; 
		
		if MatchPercentage >= 0.9 then 
			return true;
		end 
	end 
	return false 
end 

--auto gossip
GossipFuncs.AutoGossip = function() 
	local GossipTable = {GetGossipOptions()};
	local NPCName = GossipFrameNpcNameText:GetText() or ""; 
	
	local SkipIndex = 0; 
	local GossipOptionsNum = 0; 
	if _Questic.GetVariable("GossipAutoSelectSingleOptionGossip") then 
		for Gossip = 1,#GossipTable/2 do 
			if GossipTable[2 + (Gossip - 1)*2]:lower() == "gossip" or GossipTable[2 + (Gossip - 1)*2]:lower() == "chatbubble" then 
				SkipIndex = Gossip; 
				GossipOptionsNum = GossipOptionsNum + 1; 
			end 
		end 
		if SkipIndex > 0 and GossipOptionsNum == 1 then
			table.foreach(_Questic.GetVariable("GossipAutoSelectBlackList"), function(Index,GossipInfo) 
				if not GossipInfo.Disable and MatchStrings(GossipInfo.NPC,NPCName) and MatchStrings(GossipInfo.Gossip,GossipTable[1 + (SkipIndex - 1)*2]) then  
					SkipIndex = 0; 
					return nil; 
				end 
			end) 
			if SkipIndex > 0 then 
				return true, SelectGossipOption(SkipIndex);	
			end 
		end 
	end 
	
	SkipIndex = 0; 
	table.foreach(_Questic.GetVariable("GossipAutoSelectList"), function(Index,GossipInfo) 
		if not GossipInfo.Disable and MatchStrings(GossipInfo.NPC,NPCName) then  
			for Gossip = 1,#GossipTable/2 do 
				if (not GossipInfo.Skip or (GossipInfo.Skip and not _Questic.GetVariable("GossipAutoSelectIgnoreSkip"))) and MatchStrings(GossipInfo.Gossip,GossipTable[1 + (Gossip - 1)*2]) then 
					SkipIndex = Gossip; 
					if GossipInfo.Skip then 
						return nil; 
					end 
					if not _Questic.GetVariable("GossipAutoSelectPriorSkip") then 
						return nil; 
					end 
				end 
			end 
		end		
	end)	
	
	if not _Questic.GetVariable("GossipAutoSelectPriorSkip") and SkipIndex > 0 then 
		table.foreach(_Questic.GetVariable("GossipAutoSelectBlackList"), function(Index,GossipInfo) 
			if not GossipInfo.Disable and MatchStrings(GossipInfo.NPC,NPCName) and MatchStrings(GossipInfo.Gossip,GossipTable[1 + (SkipIndex - 1)*2]) then  
				SkipIndex = 0; 
				return nil; 
			end 
		end) 
		if SkipIndex > 0 then 
			return true, SelectGossipOption(SkipIndex);	
		end 
	end 
	
	table.foreach(GossipFuncs.DefaultList, function(Index,GossipInfo) 
		if not _Questic.GetVariable("GossipAutoSelectDisabledPresets")[GossipInfo.NPC..GossipInfo.Gossip..GossipInfo.Categories] and MatchStrings(GossipInfo.NPC,NPCName) then  
			for Gossip = 1,#GossipTable/2 do 
				if (not GossipInfo.Skip or (GossipInfo.Skip and not _Questic.GetVariable("GossipAutoSelectIgnoreSkip"))) and MatchStrings(GossipInfo.Gossip,GossipTable[1 + (Gossip - 1)*2]) then 
					SkipIndex = Gossip; 
					if GossipInfo.Skip then 
						return nil; 
					end 
					if not _Questic.GetVariable("GossipAutoSelectPriorSkip") then 
						return nil; 
					end 
				end 
			end 
		end		
	end)	

	if SkipIndex > 0 then 
		table.foreach(_Questic.GetVariable("GossipAutoSelectBlackList"), function(Index,GossipInfo) 
			if not GossipInfo.Disable and MatchStrings(GossipInfo.NPC,NPCName) and MatchStrings(GossipInfo.Gossip,GossipTable[1 + (SkipIndex - 1)*2]) then  
				SkipIndex = 0; 
				return nil; 
			end 
		end) 
		if SkipIndex > 0 then 
			return true, SelectGossipOption(SkipIndex);	
		end 
	end 
	
	return false; 
end 

--saved gossips
GossipFuncs.ChangeGossip = function(ListType,Index,ChangeType,Value)
	if ChangeType == "ADD" then 
		if ListType == "UserDefined" then 
			local InList = false; 
			for i,v in ipairs(_Questic.GetVariable("GossipAutoSelectList")) do 
				if v.Gossip == Value.Gossip and v.NPC == Value.NPC then 
					InList = true; 
				end 
			end 
			if not InList then 
				table.insert(_Questic.GetVariable("GossipAutoSelectList"),{NPC = Value.NPC, Gossip = Value.Gossip, Disable = Value.Disable, Note = Value.Note});
				print("Questic: \""..Value.Gossip.."\" for \""..Value.NPC.."\" added to auto-gossip.")
			else 
				print("Questic: \""..Value.Gossip.."\" for \""..Value.NPC.."\" already added to auto-gossip list.");
			end 
		elseif ListType == "Blacklist" then 
			local InList = false; 
			for i,v in ipairs(_Questic.GetVariable("GossipAutoSelectBlackList")) do 
				if v.Gossip == Value.Gossip and v.NPC == Value.NPC then 
					InList = true; 
				end 
			end 
			if not InList then 
				table.insert(_Questic.GetVariable("GossipAutoSelectBlackList"),{NPC = Value.NPC, Gossip = Value.Gossip, Disable = Value.Disable, Note = Value.Note});
				print("Questic: \""..Value.Gossip.."\" for \""..Value.NPC.."\" added to auto-gossip blacklist.")
			else 
				print("Questic: \""..Value.Gossip.."\" for \""..Value.NPC.."\" already added to auto-gossip blacklist.");
			end 
		end 
	elseif ChangeType == "REMOVE" then 
		if ListType == "UserDefined" then 
			table.remove(_Questic.GetVariable("GossipAutoSelectList"),Index);
		elseif ListType == "Blacklist" then 
			table.remove(_Questic.GetVariable("GossipAutoSelectBlackList"),Index);
		end 
	elseif ChangeType == "NPC" then 
		if ListType == "UserDefined" then 
			_Questic.GetVariable("GossipAutoSelectList")[Index].NPC = Value;
		elseif ListType == "Blacklist" then 
			_Questic.GetVariable("GossipAutoSelectBlackList")[Index].NPC = Value;
		end 
	elseif ChangeType == "Gossip" then 
		if ListType == "UserDefined" then 
			_Questic.GetVariable("GossipAutoSelectList")[Index].Gossip = Value;
		elseif ListType == "Blacklist" then 
			_Questic.GetVariable("GossipAutoSelectBlackList")[Index].Gossip = Value;
		end 
	elseif ChangeType == "Note" then 
		if ListType == "UserDefined" then 
			_Questic.GetVariable("GossipAutoSelectList")[Index].Note = Value;
		elseif ListType == "Blacklist" then 
			_Questic.GetVariable("GossipAutoSelectBlackList")[Index].Note = Value;
		end 
	elseif ChangeType == "Categories" then 
		if ListType == "UserDefined" then 
			_Questic.GetVariable("GossipAutoSelectList")[Index].Categories = Value;
		elseif ListType == "Blacklist" then 
			_Questic.GetVariable("GossipAutoSelectBlackList")[Index].Categories = Value;
		end 
	elseif ChangeType == "Disable" then 
		if ListType == "UserDefined" then 
			_Questic.GetVariable("GossipAutoSelectList")[Index].Disable = Value;
		elseif ListType == "Blacklist" then 
			_Questic.GetVariable("GossipAutoSelectBlackList")[Index].Disable = Value;
		elseif ListType == "Preset" then 
			_Questic.GetVariable("GossipAutoSelectDisabledPresets")[GossipFuncs.DefaultList[Index].NPC..GossipFuncs.DefaultList[Index].Gossip..GossipFuncs.DefaultList[Index].Categories] = Value;
		end 
	end 
end

local LastGossip = {
	NPC = "",
	Gossip = "",
	Note = "",	
};

GossipFuncs.FetchLastGossip = function(Gossip,NPCName,Note)
	if Gossip and NPCName then 
		table.wipe(LastGossip);
		LastGossip = {
			NPC = NPCName,
			Gossip = Gossip,
			Note = "",		
		}
	elseif Note then 
		LastGossip.Note = Note;
	else 
		return LastGossip;
	end 
end 

for i = 1,32 do 
	_G["GossipTitleButton"..i]:HookScript("OnClick",function(self)
		if self.type == "Gossip" and _G[self:GetName().."GossipIcon"] and (_G[self:GetName().."GossipIcon"]:GetTexture():lower():find("gossipgossipicon") or _G[self:GetName().."GossipIcon"]:GetTexture():lower():find("chatbubblegossipicon")) then
			GossipFuncs.FetchLastGossip(self:GetText(),GossipFrameNpcNameText:GetText());
		end 
	end)
end 

_Questic.GossipFrameSuppress = function(Show)
	for i = 1,32 do 
		if _G["GossipTitleButton"..i] then 
			_G["GossipTitleButton"..i]:EnableMouse(Show);
		end 
	end 
	GossipFrameGreetingGoodbyeButton:EnableMouse(Show);
	GossipFrameCloseButton:EnableMouse(Show);
	GossipFrame:EnableMouse(Show)
	GossipFrame:SetAlpha(Show and 1 or 0);
end 

for i = 1,32 do 
	if _G["GossipTitleButton"..i] then 
		_G["GossipTitleButton"..i]:HookScript("OnMouseUp",function(self,Button)
			if _Questic.GetVariable("Enable") and Button == "RightButton" and _G[self:GetName().."GossipIcon"]:GetTexture() == "Interface\\GossipFrame\\gossipGossipIcon" then 
				if (IsControlKeyDown() or IsShiftKeyDown() or IsAltKeyDown()) and _Questic.GetVariable("RightClickGossipBlacklistAdd") then 
					_Questic.GossipFunctions.ChangeGossip("Blacklist",nil,"ADD",{NPC = GossipFrameNpcNameText:GetText(),Gossip = self:GetText()});
				elseif _Questic.GetVariable("RightClickGossipAdd") then 
					_Questic.GossipFunctions.ChangeGossip("UserDefined",nil,"ADD",{NPC = GossipFrameNpcNameText:GetText(),Gossip = self:GetText()});
				end
			end 
		end)
	end 
end 
--Presets
GossipFuncs.DefaultList = {
	---------------------------------------------------------------------------------------------------------------------------
	-----------------------------------------------Kul Tiras & Zuldazar--------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------	

	-----------------------------------------------------Alliance----------------------------------------------------------------
	--Tiragarde Sound
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Cyrus Crestfall",
		["Gossip"] = "<Shake his hand.>",
	}, 	
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "7th Legion Magus",
		["Gossip"] = "The local authority has given us permission to open portals here.",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Urchin Worker",
		["Gossip"] = "Head down to the water. There is a boat waiting to take you to safety.",
	},  
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Chemist's Notes",
		["Gossip"] = "<Take the notes.>",
	},  
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Flynn Fairwind",
		["Gossip"] = "Let's go.",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Stabby Jane",
		["Gossip"] = "<Ask if she has seen Flynn.>",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Hungry Sam",
		["Gossip"] = "What's your favorite thing you lost in the wreck?",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Friendly Pete",
		["Gossip"] = "What's your favorite thing you lost in the wreck?",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Handy Bill",
		["Gossip"] = "What's your favorite thing you lost in the wreck?",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Flynn Fairwind",
		["Gossip"] = "<Help him up.>",
	},  
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Irontide Recruiter",
		["Gossip"] = "We want to join the Irontide Raiders. We brought our own hats.",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Venrik",
		["Gossip"] = "Milk... in a skull mug.",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Venrik",
		["Gossip"] = "Milk.",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Venrik",
		["Gossip"] = "Ale.",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Rodrigo",
		["Gossip"] = "Can you send this letter to Taelia in Boralus?",
	},  
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Ned",
		["Gossip"] = "<Show the poster.> What do you know about this buried treasure?",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Ned",
		["Gossip"] = "No, no. Buried treasure.",
	}, 
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Ned",
		["Gossip"] = "BURIED. TREASURE.",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Nub Nub",
		["Gossip"] = "<Show the poster.> What do you know about this buried treasure?",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Nance Barmy",
		["Gossip"] = "<Show the poster.> What do you know about this buried treasure?",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "First Mate Trixie Tornsail",
		["Gossip"] = "Yarr! Some brine-brained scalawag be sullyin' the good name of the Irontide Raiders! Just over there, behind that building!",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Proudmoore Guard",
		["Gossip"] = "The Lord Admiral is in danger. Come with us!",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Civil Technician Alena",
		["Gossip"] = "Theock wants to retake the mine.",
	},
	{
		["Categories"] = "BfA|Alliance|Tiragarde Sound",
		["NPC"] = "Ordnance Handler Prim",
		["Gossip"] = "Theock wants to retake the mine.",
	},
 
	-----------------------------------------------------Horde----------------------------------------------------------------
	--Zuldazar
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "Princess Talanji",
		["Gossip"] = "Take me to King Rastakhan.",				
		--["Note"] = "Introduction quest: first meeting Rastakhan.",	
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Nokali the Scarred", 
		["Gossip"] = "<Show him the Word of Zul.>"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Doomsayer Volkini", 
		["Gossip"] = "<Show her the Word of Zul.>"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Dockmaster Cobo", 
		["Gossip"] = "<Show him the Word of Zul.>"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Cala Cruzpot", 
		["Gossip"] = "Can you work with Jangalar to solve this problem?"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Cala Cruzpot", 
		["Gossip"] = "Jangalar is attuned to the dinosaurs. Can you use that?"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Cala Cruzpot", 
		["Gossip"] = "I will let Jangalar know."
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Witch Doctor Jangalar", 
		["Gossip"] = "Can Cala's science help?"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Witch Doctor Jangalar", 
		["Gossip"] = "Her alchemy does affect the dinosaurs. Can your voodoo make it work correctly?"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Witch Doctor Jangalar", 
		["Gossip"] = "Let's try again."
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Kraal Master B'khor", 
		["Gossip"] = "I'm ready to train."
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Toki",
		["Gossip"] = "I am ready.",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Scrollsage Rooka",
		["Gossip"] = "I have lost my disguise. Do you have another scroll?",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Orphan Toe",
		["Gossip"] = "Lead da way.",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Orphan Tak",
		["Gossip"] = "Lead da way.",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Orphan Tik",
		["Gossip"] = "Lead da way.",
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jamil Abul'housin", 
		["Gossip"] = "How goes the mending?"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jol the Ancient", 
		["Gossip"] = "How goes the mending?"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jol the Ancient", 
		["Gossip"] = "I am ready, Jol."
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jol the Ancient",
		["Gossip"] = "<Offer Astringent Spices: |TInterface\\ICONS\\INV_Misc_Dust_01.blp:20|t>",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jol the Ancient",
		["Gossip"] = "<Offer Sea Urchin Brine: |TInterface\\ICONS\\INV_Misc_Food_Legion_gooOil_multi.BLP:20|t>",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jol the Ancient",
		["Gossip"] = "<Offer Ancient Tortollan Scroll: |TInterface\\ICONS\\TRADE_ARCHAEOLOGY_SILVERSCROLLCASE.BLP:20|t>",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jol the Ancient",
		["Gossip"] = "<Offer Clotting Powder: |TInterface\\ICONS\\INV_MISC_POWDER_COPPER.BLP:20|t>",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "King Rastakhan",
		["Gossip"] = "Let's get out of here!",
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Rezan", 
		["Gossip"] = "Rastakhan is injured and will not wake. We need your help."
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "King Rastakhan", 
		["Gossip"] = "What now?"
	},
    {
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "King Rastakhan", 
		["Gossip"] = "Time to leave!"
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Jani",
		["Gossip"] = "I have a shiny trinket for you, Jani.",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar", 
		["NPC"] = "Apprentice Telemancer Astrandis",
		["Gossip"] = "Let's begin.",
	},
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "King Rastakhan",
		["Gossip"] = "I am ready to defend Zandalar.",
	}, -- [8]
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "Rakle the Wretched",
		["Gossip"] = "Make for Princess Talanji and Warguard Rakera.",
	}, -- [9]
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "Chronicler Bah'kini",
		["Gossip"] = "Make for Princess Talanji and Warguard Rakera.",
	}, -- [10]
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "Madam Konawla",
		["Gossip"] = "Make for Princess Talanji and Warguard Rakera.",
	}, -- [11]
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "No'ci the Scribe",
		["Gossip"] = "Make for Princess Talanji and Warguard Rakera.",
	}, -- [12]
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "Trader Haw'li",
		["Gossip"] = "Make for Princess Talanji and Warguard Rakera.",
	}, -- [13]
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "Toko",
		["Gossip"] = "Make for Princess Talanji and Warguard Rakera.",
	}, -- [14]
	{
		["Categories"] = "BfA|Horde|Zuldazar",
		["NPC"] = "Moj'ito",
		["Gossip"] = "Make for Princess Talanji and Warguard Rakera.",
	}, -- [15]
	--Nazmir
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] =  "Paku'ai Rokota",
		["Gossip"] =  "Get me as close as you can to Nazmir.",
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] =  "Princess Talanji",
		["Gossip"] =  "We need to move, we shouldn't stay here.",
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] =  "Princess Talanji",
		["Gossip"] =  "Let's discuss what we can do to fight the blood trolls.",
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] =  "Sur'jan",
		["Gossip"] =  "Show me Urok, the Terror of the Wetlands.",
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Witch Doctor Kejabu", 
		["Gossip"] = "I'm ready to begin the ritual to disguise myself as a blood troll."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Bloodseeker Jo'chunga", 
		["Gossip"] = "Kejabu sent me."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Bloodseeker Jo'chunga", 
		["Gossip"] = "All right... Jo'chunga! I need ya in dat hut over dere ta be gettin' a blood ritual ready."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Teshyambi", 
		["Gossip"] = "(Leave)" 
	},
	
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Mojoba", 
		["Gossip"] = "I know who you are, Mojoba. Proceed to Vol'dun and live out your exile in peace."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Zaluto", 
		["Gossip"] = "Hold still, Zaluto. We are going to cure your infection."
	},
	
	
 
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Wardrummer Saljo", 
		["Gossip"] = "Da camp be needin' more wood. Go an' retrieve thirty pieces of only da most pristine lumber!"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Wardrummer Sheej", 
		["Gossip"] = "Da camp be needin' more stone. Go an' recover only da purest of rocks within Nazmir. Sixty of dem."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Wardrummer Gix", 
		["Gossip"] = "We be needin' fifty pristine crocolisk hides. Go an' retrieve dem, and don' be comin' back 'til you have dem all."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Jo'chunga", 
		["Gossip"] = "Jo'chunga, I'm ready. Let's enact our plan to stop Hir'eek."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Zardrax the Empowerer", 
		["Gossip"] = "Alright, lich, tell me your offer."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Shadow Hunter Da'jul", 
		["Gossip"] = "I'm ready to receive your fire mojo to destroy the burial mounds."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Kal'dran", 
		["Gossip"] = "Calm down, Kal'dran. We can still defeat Zardrax."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Razjuto", 
		["Gossip"] = "I'm sorry, but you've been exiled to Vol'dun for your crimes."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Razjuto", 
		["Gossip"] = "Do you want to go back to Zuldazar and be killed, or stay here and be killed by raptors?"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Chadwick Paxton", 
		["Gossip"] = "Alright, I've got your... legs. What next?"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Ingrid Bellix", 
		["Gossip"] = "I need you to empower the Skycaller Gem."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Bwonsamdi", 
		["Gossip"] = "Let's begin."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Witch Doctor Kejabu", 
		["Gossip"] = "Jo'chunga is alive, the loa Hir'eek though..."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Princess Talanji", 
		["Gossip"] = "(Tell Talanji about getting Bwonsamdi's aid and killing Hir'eek.)"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Lashk", 
		["Gossip"] = "Tell me about this pilgrimage you're on."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Shoak", 
		["Gossip"] = "Kajosh sent me. I'll handle the mawfiends."
	},
	
	
	
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Kisha", 
		["Gossip"] = "Lashk said you could tell me where I can find Torga."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Kajosh", 
		["Gossip"] = "Some of the totems are destroyed, will your spell work now?"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Princess Talanji", 
		["Gossip"] = "I'm ready to try and summon Bwonsamdi."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Bwonsamdi", 
		["Gossip"] = "Bwonsamdi, we're ready for you to summon Torga's spirit."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Crez", 
		["Gossip"] = "(Tell Crez about what happened to Torga, and the chance for new stories to be told if he goes to Gloom Hollow.)"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Korkush", 
		["Gossip"] = "(Tell Korkush there's a great story to be had if he helps the Horde fight the blood trolls and save the Zandalari.)"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Yash", 
		["Gossip"] = "(Tell Yash if he wants to live a crazy story that he should go to Gloom Hollow to help stop the blood trolls and their god.)"
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Krag'wa the Huge", 
		["Gossip"] = "I am ready to fight the blood trolls."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Newt's Emergency Rocket", 
		["Gossip"] = "Let's ride out of here."
	},
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Titan Keeper Hezrel", 
		["Gossip"] = "Hezrel, begin your scans to find a solution to the Old God corruption with Nazmir."
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Patch",
		["Gossip"] = "I'm ready, let's hop on this barge and get back to Zul'jan.",
	},
	
	
    {
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Princess Talanji", 
		["Gossip"] = "I'm ready."
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Krag'wa the Huge",
		["Gossip"] = "Krag'wa, the leader of the blood trolls has fled to the large structure in the distance. Please, lend us your assistance.",
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Krag'wa the Huge",
		["Gossip"] = "I am ready to go, Krag'wa.",
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Rokhan",
		["Gossip"] = "Let's fly down and meet with Titan Keeper Hezrel.",
	},
	{
		["Categories"] = "BfA|Horde|Nazmir", 
		["NPC"] = "Rokhan",
		["Gossip"] = "Take me back to Zul'jan.",
	},
	--Vol'dun
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Enforcer Dakanji", 
		["Gossip"] = "What can you tell me about General Jakra'zet?"
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Enforcer Gortok", 
		["Gossip"] = "What can you tell me about General Jakra'zet?"
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Enforcer Sekal", 
		["Gossip"] = "What can you tell me about General Jakra'zet?"
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Meerah", 
		["Gossip"] = "We're ready to leave."
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Akunda the Exalted", 
		["Gossip"] = "My name is Akunda the Nimble." --Nimble or Serene or Courageous
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Vorrik", 
		["Gossip"] = "<Give Vorrik Sulthis' Stone.>"
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", --check this one again
		["NPC"] = "Razgaji", 
		["Gossip"] = "I'm ready. Let's go."
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Vulpera Slave", 
		["Gossip"] = "<Free the slave and give them a weapon to fight with.>"
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Rakjan the Unbroken", 
		["Gossip"] = "Let's ride."
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Vorrik", 
		["Gossip"] = "Vorrik, I'm ready to face Emperor Korthek."
	},
    {
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Vorrik", 
		["Gossip"] = "I'm ready. Let's go find the others."
	},	
	{
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Scorched Sands Outcast",
		["Gossip"] = "The battle is approaching. Take this sword and remain vigilant.",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Shady Deckhand",
		["Gossip"] = "I know you've been stealing from the company. I'm here to make sure it doesn't happen again...",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Volni",
		["Gossip"] = "Umm... Hello?",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Man'zul",
		["Gossip"] = "Your eyepatch is very fearsome.",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun", 
		["NPC"] = "Grenja",
		["Gossip"] = "Well met!",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun",
		["NPC"] = "Zauljin",
		["Gossip"] = "Here's the rum. Tell me what you heard.",
	},
	
	{
		["Categories"] = "BfA|Horde|Vol'dun",
		["NPC"] = "Elder Kuppaka",
		["Gossip"] = "Torka asked me to deliver this to you.",
	}, 
	{
		["Categories"] = "BfA|Horde|Vol'dun",	
		["NPC"] = "Statue of Eraka No Kimbul",
		["Gossip"] = "I seek the loa's blessing.",
	}, 
	{
		["Categories"] = "BfA|Horde|Vol'dun",	
		["NPC"] = "Statue of Eraka No Kimbul",
		["Gossip"] = "Act with courage in all matters.",
	}, 
	{
		["Categories"] = "BfA|Horde|Vol'dun",	
		["NPC"] = "Statue of Eraka No Kimbul",
		["Gossip"] = "An indomitable will.",
	}, 
	{
		["Categories"] = "BfA|Horde|Vol'dun",	
		["NPC"] = "Statue of Eraka No Kimbul",
		["Gossip"] = "A life lived with honor.",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun",	
		["NPC"] = "Statue of Eraka No Kimbul",
		["Gossip"] = "They see that they belong to nature.",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun",
		["NPC"] = "Kimbul",
		["Gossip"] = "Great loa, this is offering is from the Tortaka tribe.",
	},
	{
		["Categories"] = "BfA|Horde|Vol'dun",
		["NPC"] = "Kimbul",
		["Gossip"] = "Send me to the battlefield.",
	},
	--War campaign 
	{
		["Categories"] = "BfA|Horde|War campaign",
		["NPC"] = "Huelo",
		["Gossip"] = "Pull the harpoon free.",
	}, -- [1]
	{
		["Categories"] = "BfA|Horde|War campaign",
		["NPC"] = "Eitrigg",
		["Gossip"] = "Yes, I'm ready to go to Drustvar.",
	}, -- [2]
	{
		["Categories"] = "BfA|Horde|War campaign",
		["NPC"] = "Hobart Grapplehammer",
		["Gossip"] = "Your friends were all tortured and killed by witches.",
	}, -- [3]
	{
		["Categories"] = "BfA|Horde|War campaign",
		["NPC"] = "Hobart Grapplehammer",
		["Gossip"] = "Sure.",
	}, -- [4]
	{
		["Categories"] = "BfA|Horde|War campaign",
		["NPC"] = "Wormhole",
		["Gossip"] = "<Reach inside and pull something out.>",
	}, -- [5]
	{
		["Categories"] = "BfA|Horde|War campaign",
		["NPC"] = "Wormhole",
		["Gossip"] = "<Reach inside and pull out something that feels more like a building.>",
	}, -- [6]
	{
		["Categories"] = "BfA|Horde|War campaign",
		["NPC"] = "Shadow Hunter Ty'jin",
		["Note"] = "",
		["Gossip"] = "I'm ready to parley, Ty'jin.",
	}, -- [7]
	-- World quests 
	--[[
	{
		["Categories"] = "BfA|Horde|World quests",
		["NPC"] = "Paratrooper Jacobs",
		["Gossip"] = "I need to infiltrate the Proudmoore Academy.",
	}, -- [16]
	{
		["Categories"] = "BfA|Horde|World quests",
		["NPC"] = "Collector Kojo",
		["Gossip"] = "I am ready.",
	}, 
	]]
	---shared
	
	{
		["Categories"] = "BfA|Shared",
		["NPC"] = "Magni Bronzebeard",
		["Note"] = "",
		["Gossip"] = "Magni, I'm ready for you to empower the Heart of Azeroth.",
	},
	
	---------------------------------------------------------------------------------------------------------------------------
	-----------------------------------------------------Intro stuff-----------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------
	
	-----------------------------------------------------Shared----------------------------------------------------------------
	{
		["Categories"] = "BfA|Pre Event|Shared", 
		["NPC"] = "Magni Bronzebeard",
		["Gossip"] = "What does Azeroth want of me, Magni?",
	},
	-----------------------------------------------------Alliance----------------------------------------------------------------
	--pre event part 1
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Anduin Wrynn",
		["Gossip"] = "I've heard this tale before... <Skip the scenario and begin your next mission.>",
		["Note"] = "Skip prioritization if that option is enabled.",
		["Skip"] = true,
	},
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Druid of the Claw",
		["Gossip"] = "You must defend the Grove of the Ancients!",
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Elder Brolg",
		["Gossip"] = "Come with us to safety. We will not harm you.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Elder Brownpaw",
		["Gossip"] = "Come with us to safety. We will not harm you.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Gren Tornfur",
		["Gossip"] = "Come with us to safety. We will not harm you.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Janthes Shadeleaf",
		["Gossip"] = "The Horde have halted their advance at the Wildbend River! We must push them back at once!",
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Myara Sunsong",
		["Gossip"] = "Captain, the Horde have reached the Wildbend River! We cannot hold them for long!",
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Astarii Starseeker",
		["Gossip"] = "Priestess, we require your aid to hold the Horde at Wildbend River.",
	},
	--pre event part 2
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Lor'danel Citizen",
		["Gossip"] = "I have cleared a path -- you must escape now!",
	},
	{
		["Categories"] = "BfA|Pre Event|Alliance",
		["NPC"] = "Tarelvir",
		["Gossip"] = "The flames are clear! Get to the Temple of the Moon!",
	},
	{
		["Categories"] = "BfA|Pre Event|Alliance",
		["NPC"] = "Darnassian Citizen",
		["Gossip"] = "The flames are clear! Get to the Temple of the Moon!",
	},
	{
		["Categories"] = "BfA|Pre Event|Alliance",
		["NPC"] = "Turian",
		["Gossip"] = "The flames are clear! Get to the Temple of the Moon!",
	},
	--pre event Lordaeron
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Captain Angelica",
		["Gossip"] = "I've heard this tale before... <Skip the scenario and begin your next mission.>",
		["Note"] = "Skip prioritization if that option is enabled.",
		["Skip"] = true,
	},
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Captain Angelica",
		["Gossip"] = "I am ready to sail to Lordaeron.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Lady Jaina Proudmoore",
		["Gossip"] = "I've heard this tale before... <Skip the Kul Tiras introductory quests and begin your journey in Boralus.>",
		["Note"] = "Skip prioritization if that option is enabled.",
		["Skip"] = true,
	},	
	{
		["Categories"] = "BfA|Pre Event|Alliance", 
		["NPC"] = "Lady Jaina Proudmoore",
		["Gossip"] = "I'm ready to set sail!",
	},	
	-----------------------------------------------------Horde----------------------------------------------------------------
	
	--pre event part 1
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Lady Sylvanas Windrunner",
		["Gossip"] = "Warchief, may I ask why we want to capture Teldrassil?",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Lady Sylvanas Windrunner",
		["Gossip"] = "I've heard this tale before... <Skip the scenario and begin your next mission.>",
		["Note"] = "Skip prioritization if that option is enabled.",
		["Skip"] = true,
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Lady Sylvanas Windrunner",
		["Gossip"] = "It is uncertain, Warchief.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Lady Sylvanas Windrunner",
		["Gossip"] = "The night elves will fight us at every step.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Commander Grimfang",
		["Gossip"] = "Commander, the warchief asks that you prepare your outpost for an incoming army.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Innkeeper Duras",
		["Gossip"] = "The warchief needs rations and lodging for an incoming army.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Dagrun Ragehammer",
		["Gossip"] = "Warchief Sylvanas Windrunner requires your aid repairing her soldiers' weapons.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Zarvik Blastwix",
		["Gossip"] = "Let's fly.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Lady Sylvanas Windrunner",
		["Gossip"] = "Where do we go from here, Warchief?",
	},		
	--pre event part 2
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Lor'danel Citizen",
		["Gossip"] = "Come with us to safety. We will not harm you.",
	},
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Lady Sylvanas Windrunner",
		["Gossip"] = "I am ready.",
	},
		
	--pre event Lordaeron
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Isabella",
		["Gossip"] = "I am ready to go to the Undercity.",
	},	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Isabella",
		["Gossip"] = "I've heard this tale before... <Skip the scenario and begin your next mission.>",
		["Note"] = "Skip prioritization if that option is enabled.",
		["Skip"] = true,
	},
	--[[
	The Undercity is under attack! Get to the mage portal! Morley Bates
	What are you up to? You need to evacuate with the rest of us! Bilgewater Blastmasters
	The Undercity is under attack! Get to the mage portal! Victor Ward
	
	The Undercity is under attack! Get to the mage portal! Sydney Upton
The Undercity is under attack! Get to the mage portal! Sydney Upton
Millie Gregorian
The Undercity is under attack! Get to the mage portal! Millie Gregorian
The Undercity is under attack! Get to the mage portal! Millie Gregorian
Lucille Castleton
The Undercity is under attack! Get to the mage portal! Lucille Castleton

The Undercity is under attack! Get to the mage portal! Lucille Castleton
The Undercity is under attack! Get to the mage portal! Lucille Castleton
Godrick Farsan
The Undercity is under attack! Get to the mage portal! Godrick Farsan
The Undercity is under attack! Get to the mage portal! Godrick Farsan
Godrick Farsan
The Undercity is under attack! Get to the mage portal! Godrick Farsan
The Undercity is under attack! Get to the mage portal! Godrick Farsan
Samantha Shackleton
The Undercity is under attack! Get to the mage portal! Samantha Shackleton
The Undercity is under attack! Get to the mage portal! Samantha Shackleton
Godrick Farsan
The Undercity is under attack! Get to the mage portal! Godrick Farsan
The Undercity is under attack! Get to the mage portal! Godrick Farsan
Samantha Shackleton
The Undercity is under attack! Get to the mage portal! Samantha Shackleton
The Undercity is under attack! Get to the mage portal! Samantha Shackleton
Salazar Bloch
The Undercity is under attack! Get to the mage portal! Salazar Bloch
The Undercity is under attack! Get to the mage portal! Salazar Bloch
Josef Gregorian
The Undercity is under attack! Get to the mage portal! Josef Gregorian]]
	
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Sludge Guard",
		["Gossip"] = "Gas mask and blight canister, please. I want to see what this thing can do.",
	},	
 	
	
	--stormwind scenario
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "High Overlord Saurfang", 
		["Gossip"] = "What do you mean?"
	},
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Rokhan", 
		["Gossip"] = "Let's go.",
		["EscortStart"] = true,
	},
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Rokhan", 
		["Gossip"] = "I will be right behind you.",
		["EscortStart"] = true,
	},
	{
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Nathanos Blightcaller", 
		["Gossip"] = "I'm ready.",
		["EscortStart"] = true,
	},
	
	
    {
		["Categories"] = "BfA|Pre Event|Horde", 
		["NPC"] = "Princess Talanji", 
		["Gossip"] = "Not at all."
	},
	
	
	 
	
	---------------------------------------------------------------------------------------------------------------------------
	-----------------------------------------------------Legacy Dungeons-------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------
    {
		["Categories"] = "Legacy Dungeons|Ahune",
		["NPC"] = "Ice Stone",
		["Gossip"] = "Disturb the stone and summon Lord Ahune."
	}, 
	
	---------------------------------------------------------------------------------------------------------------------------
	-----------------------------------------------------Legacy Questing-------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------
    {
		["Categories"] = "Legacy Questing|Garrison",
		["NPC"] = "Skaggit",
		["Gossip"] = "Get the peons back to work."
	}, 
    {
		["Categories"] = "Legacy Questing|Garrison",
		["NPC"] = "Senior Peon II",
		["Gossip"] = "Gazlowe needs you."
	}, 	
    {
		["Categories"] = "Legacy Questing|Withered Training",
		["NPC"] = "First Arcanist Thalyssra",
		["Gossip"] = "I'm ready!"
	}, 
	
	---------------------------------------------------------------------------------------------------------------------------
	-----------------------------------------------------Legacy Raids---------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------
	{
		["Categories"] = "Legacy Raids|Caverns of Time",
		["NPC"] = "Steward of Time",
		["Gossip"] = "Please take me to the master's lair."
	},
    {
		["Categories"] = "Legacy Raids|Isle of Thunder Scenario",
		["NPC"] = "Scout Captain Elsia",
		["Gossip"] = "I'm ready to go."
	}, 
    {
		["Categories"] = "Legacy Raids|Molten Core",
		["Note"] = "Entrance Orb",
		["NPC"] = "Lothos Riftwaker",
		["Gossip"] = "Transport me to the Molten Core, Lothos."
	},
    {
		["Categories"] = "Legacy Raids|Molten Core",
		["Note"] = "Ragnaros 1",
		["NPC"] = "Majordomo Executus",
		["Gossip"] = "Tell me more."
	},
    {
		["Categories"] = "Legacy Raids|Molten Core",
		["Note"] = "Ragnaros 2",
		["NPC"] = "Majordomo Executus",
		["Gossip"] = "What else do you have to say?"
	},
    {
		["Categories"] = "Legacy Raids|Molten Core",
		["Note"] = "Ragnaros 3",
		["NPC"] = "Majordomo Executus",
		["Gossip"] = "You challenged us and we have come. Where is this master you speak of?"
	},
    {
		["Categories"] = "Legacy Raids|Blackwing Lair",
		["Note"] = "Orb of Command",
		["NPC"] = "Orb of Command",
		["Gossip"] = "<Place my hand on the orb.>"
	}, 
    {
		["Categories"] = "Legacy Raids|Blackwing Lair",
		["Note"] = "Vaelastrasz 1",
		["NPC"] = "Vaelastrasz the Corrupt",
		["Gossip"] = "I cannot, Vaelastrasz! Surely something can be done to heal you!"
	}, 
    {
		["Categories"] = "Legacy Raids|Blackwing Lair",
		["Note"] = "Vaelastrasz 2",
		["NPC"] = "Vaelastrasz the Corrupt",
		["Gossip"] = "Vaelastrasz, no!!!"
	},
    {
		["Categories"] = "Legacy Raids|Blackwing Lair",
		["Note"] = "Nefarian 1",
		["NPC"] = "Lord Victor Nefarius",
		["Gossip"] = "I've made no mistakes."
	},
    {
		["Categories"] = "Legacy Raids|Blackwing Lair",
		["Note"] = "Nefarian 2",
		["NPC"] = "Lord Victor Nefarius",
		["Gossip"] = "You have lost your mind, Nefarius. You speak in riddles."
	},
    {
		["Categories"] = "Legacy Raids|Blackwing Lair",
		["Note"] = "Nefarian 3",
		["NPC"] = "Lord Victor Nefarius",
		["Gossip"] = "Please do."
	},
    {
		["Categories"] = "Legacy Raids|Black Temple",
		["Note"] = "Akama 1",
		["NPC"] = "Akama",
		["Gossip"] = "I'm ready, Akama."
	},
    {
		["Categories"] = "Legacy Raids|Black Temple",
		["Note"] = "Akama 2",
		["NPC"] = "Akama",
		["Gossip"] = "We're ready to face Illidan."
	}, 
    {
		["Categories"] = "Legacy Raids|Black Temple",
		["Note"] = "Akama 3",
		["NPC"] = "Akama",
		["Gossip"] = "I'm with you, Akama."
	}, 
    {
		["Categories"] = "Legacy Raids|Mount Hyjal",
		["Note"] = "Wave 1",
		["NPC"] = "Lady Jaina Proudmoore",
		["Gossip"] = "My companions and I are with you, Lady Proudmoore."
	},
    {
		["Categories"] = "Legacy Raids|Mount Hyjal",
		["Note"] = "Wave 2",
		["NPC"] = "Lady Jaina Proudmoore",
		["Gossip"] = "We are ready for whatever Archimonde might send our way, Lady Proudmoore."
	},
    {
		["Categories"] = "Legacy Raids|Mount Hyjal",
		["Note"] = "Mass Teleport",
		["NPC"] = "Lady Jaina Proudmoore",
		["Gossip"] = "Until we meet again, Lady Proudmoore."
	},
    {
		["Categories"] = "Legacy Raids|Mount Hyjal",
		["Note"] = "Wave 3",
		["NPC"] = "Thrall",
		["Gossip"] = "I am with you, Thrall."
	},
    {
		["Categories"] = "Legacy Raids|Mount Hyjal",
		["Note"] = "Wave 4",
		["NPC"] = "Thrall",
		["Gossip"] = "We have nothing to fear."
	},
    {
		["Categories"] = "Legacy Raids|Mount Hyjal",
		["Note"] = "Continue",
		["NPC"] = "Thrall",
		["Gossip"] = "Until we meet again, Thrall."
	},
    {
		["Categories"] = "Legacy Raids|Mount Hyjal",
		["Note"] = "Aid",
		["NPC"] = "Tyrande Whisperwind",
		["Gossip"] = "I would be grateful for any aid you can provide, Priestess."
	},
    {
		["Categories"] = "Legacy Raids|Ulduar",
		["Note"] = "Start",
		["NPC"] = "Brann Bronzebeard",
		["Gossip"] = "We're ready. Begin the assault!"
	}, 
    {
		["Categories"] = "Legacy Raids|Ulduar",
		["Note"] = "Razorscale",
		["NPC"] = "Expedition Commander",
		["Gossip"] = "We are ready to help!"
	}, 
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Icehowl 1",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "I have completed the Trial of the Crusader."
	}, 
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Icehowl 2",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "Yes. We are prepared for the challenges ahead of us."
	}, 
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Icehowl 3",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "Bring forth the first challenge!"
	}, 
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Lord Jaraxxus 1",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "What new challenge awaits us?"
	}, 
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Lord Jaraxxus 2",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "We're ready for the next challenge."
	},
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Faction 1",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "Of course!"
	}, 
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Faction 2",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "Give the signal! We're ready to go!"
	},
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Valkyr Twins 1",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "That tough, huh?"
	}, 
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Valkyr Twins 2",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "Val'kyr? We're ready for them."
	}, --buggy
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Anub'Yarak 1",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "Your words of praise are appreciated, Coliseum Master."
	},
    {
		["Categories"] = "Legacy Raids|Trial of the Crusader",
		["Note"] = "Anub'Yarak 2",
		["NPC"] = "Barrett Ramsey",
		["Gossip"] = "That is strange..."
	}, 
    {
		["Categories"] = "Legacy Raids|Icecrown Citadel",
		["Note"] = "Gunship Battle Rocket Pack",
		["NPC"] = "Zafod Boombox",
		["Gossip"] = "Yeah, I'm sure safety is your top priority. Give me a rocket pack."
	}, 
    {
		["Categories"] = "Legacy Raids|Icecrown Citadel",
		["Note"] = "Gunship Battle Start",
		["NPC"] = "High Overlord Saurfang",
		["Gossip"] = "My companions are all accounted for, Saurfang. Let's go!"
	}, 
    {
		["Categories"] = "Legacy Raids|Icecrown Citadel",
		["Note"] = "Deathbringer Saurfang 1",
		["NPC"] = "High Overlord Saurfang",
		["Gossip"] = "We are ready to go, High Overlord. The Lich King must fall!"
	},
    {
		["Categories"] = "Legacy Raids|Icecrown Citadel",
		["Note"] = "Deathbringer Saurfang 2",
		["NPC"] = "High Overlord Saurfang",
		["Gossip"] = "Lok'tar ogar! We are ready! Onward, brother orc!"
	},
    {
		["Categories"] = "Legacy Raids|Icecrown Citadel",
		["Note"] = "Lich King",
		["NPC"] = "Highlord Tirion Fordring",
		["Gossip"] = "We are prepared, Highlord. Let us battle for the fate of Azeroth! For the light of dawn!"
	},
    {
		["Categories"] = "Legacy Raids|Blackwing Descent",
		["Note"] = "Orb of Culmination",
		["NPC"] = "Orb of Culmination",
		["Gossip"] = "<Place my hand on the orb.>"
	},
    {
		["Categories"] = "Legacy Raids|Firelands",
		["Note"] = "Magma Orb",
		["NPC"] = "Magma Orb",
		["Gossip"] = "<Pick up the orb and shake it vigorously.>"
	},
    {
		["Categories"] = "Legacy Raids|Dragonsoul",
		["Note"] = "Kalecgos",
		["NPC"] = "Kalecgos",
		["Gossip"] = "We were successful, Kalecgos."
	}, 
    {
		["Categories"] = "Legacy Raids|Dragonsoul",
		["Note"] = "Thrall",
		["NPC"] = "Thrall",
		["Gossip"] = "You may begin your ritual, we will defend you."
	}, 
    {
		["Categories"] = "Legacy Raids|Dragonsoul",
		["Note"] = "Warship 1",
		["NPC"] = "Sky Captain Swayze",
		["Gossip"] = "We are the Horde. We are always ready."
	},
    {
		["Categories"] = "Legacy Raids|Dragonsoul",
		["Note"] = "Warship 2",
		["NPC"] = "Sky Captain Swayze",
		["Gossip"] = "Bring us in closer!"
	}, 
    {
		["Categories"] = "Legacy Raids|Dragonsoul",
		["Note"] = "Spine",
		["NPC"] = "Sky Captain Swayze",
		["Gossip"] = "FOR THE HORDE!"
	},
    {
		["Categories"] = "Legacy Raids|Dragonsoul",
		["Note"] = "Deathwing 1",
		["NPC"] = "Thrall",
		["Gossip"] = "We defeated the Destroyer!"
	},
    {
		["Categories"] = "Legacy Raids|Dragonsoul",
		["Note"] = "Deathwing 2",
		["NPC"] = "Thrall",
		["Gossip"] = "Inconceivable! He couldn't possibly be alive!"
	},
    {
		["Categories"] = "Legacy Raids|Mogu'shan Vaults",
		["Note"] = "Spiritbinder",
		["NPC"] = "Lorewalker Cho",
		["Gossip"] = "What are you waiting for? Let's go investigate!"
	}, --buggy
    {
		["Categories"] = "Legacy Raids|Mogu'shan Vaults",
		["Note"] = "Elegon",
		["NPC"] = "Lorewalker Cho",
		["Gossip"] = "Go ahead and turn this thing on."
	},
    {
		["Categories"] = "Legacy Raids|Throne Of Thunder",
		["Note"] = "Lei Shen",
		["NPC"] = "Displacement Pad",
		["Gossip"] = "Use Displacement Pad."
	},
    {
		["Categories"] = "Legacy Raids|Siege of Orgrimmar",
		["Note"] = "Norushen",
		["NPC"] = "Norushen",
		["Gossip"] = "We are ready, Keeper."
	},
    {
		["Categories"] = "Legacy Raids|Siege of Orgrimmar",
		["Note"] = "Galakras Ship",
		["NPC"] = "Lor'themar Theron",
		["Gossip"] = "Reporting for duty!"
	},
    {
		["Categories"] = "Legacy Raids|Siege of Orgrimmar",
		["Note"] = "Galakras",
		["NPC"] = "Lor'themar Theron",
		["Gossip"] = "By your command."
	},
    {
		["Categories"] = "Legacy Raids|Siege of Orgrimmar",
		["Note"] = "Spoils",
		["NPC"] = "Secured Stockpile of Pandaren Spoils",
		["Gossip"] = "Warchief Hellscream"
	},
    {
		["Categories"] = "Legacy Raids|Highmaul",
		["Note"] = "Beginning",
		["NPC"] = "Gharg",
		["Gossip"] = "We are ready, Gharg!"
	},
    {
		["Categories"] = "Legacy Raids|Highmaul",
		["Note"] = "Arena Port",
		["NPC"] = "Gharg",
		["Gossip"] = "Send me to the arena, Gharg."
	},
    
    {
		["Categories"] = "Legacy Raids|Kara",
		["Note"] = "Nightbane",
		["NPC"] = "Image of Medivh",
		["Gossip"] = "Medivh? Is that you?"
	}, 
    {
		["Categories"] = "Legacy Raids|Court Of Stars",
		["Note"] = "Boat",
		["NPC"] = "Signal Lantern",
		["Gossip"] = "Send a signal to Ly'leth Lunastre"
	},
    {
		["Categories"] = "Legacy Raids|Court Of Stars",
		["Note"] = "Suspect",
		["NPC"] = "Suspicious Noble",
		["Gossip"] = "Don't be coy. I know you're here to spy for the Grand Magistrix."
	},
    
    
    {
		["Categories"] = "Legacy Raids|Tomb Of Sargeras",
		["Note"] = "LFR Krosus",
		["NPC"] = "Image of Khadgar",
		["Gossip"] = "I'm ready."
	},
    {
		["Categories"] = "Legacy Raids|Antorus",
		["Note"] = "Argus",
		["NPC"] = "Magni Bronzebeard",
		["Gossip"] = "I'm ready."
	},
	
	

};