local _Questic = _Questic_ADDON_Globals;
local Pool = CreatePoolCollection();

local function UpdateGossip(self,Show,Preview)
	if Preview and self.ActiveGossip then 
		return nil; 
	end 
	Pool:ReleaseAll();
	if Show and _Questic.GetVariable("Enable") and _Questic.GetVariable("GossipQuickSelect") then 
		local GossipTable = {GetGossipOptions()};
		GossipTable = GossipTable or {};
		local ResetPos = false; 
		if Preview and not self.ActiveGossip then 
			ResetPos = true; 
			GossipTable = {"Trade","vendor","Speech","gossip"}
		elseif not self.ActiveGossip then 
			ResetPos = true; 
			self.ActiveGossip = true;
		end 
		
		local ActiveQuests = {};
		local AvailiableQuests = {};
		if _Questic.GetVariable("IncludeQuestsInGosseipSelect") then 
			ActiveQuests, AvailiableQuests = _Questic.FetchOfferedQuests();
		end 
		if #GossipTable > 0 or #AvailiableQuests > 0 or #ActiveQuests > 0 or _Questic.GetVariable("HideBlizzGossipFrame") then
			local GossipItems = #GossipTable/2;
			
			if not self:IsShown() or ResetPos then 
				self:UpdateParameters(true);
			end 
			
			local Height = _Questic.BorderSize;
			--Gossip
			for i = 1,GossipItems do 
				local Button = Pool:Acquire("Questic_ADDON_OptionsButtonTemplate");
				local Icon = "Interface\\GossipFrame\\"..GossipTable[2 + (i - 1)*2].."GossipIcon.blp";
				Button.Text:SetText(string.format("|T%s:0|t",Icon).." "..GossipTable[1 + (i - 1)*2]);	
				Button.Text:SetJustifyH("LEFT");
				Button.GossipIndex = i;
				Button.PreviewButton = Preview;
				Button:SetScript("OnClick",function(self,Button)
					if not _Questic.GetVariable("RightClickGossipAdd") or Button == "LeftButton" then 
						if self.PreviewButton then 
							Questic_ADDON_GossipQuickSelectFrame:Hide();
						else 
							if GossipTable[2 + (i - 1)*2]:lower() == "gossip" or GossipTable[2 + (i - 1)*2]:lower() == "chatbubble" then 
								_Questic.GossipFunctions.FetchLastGossip(GossipTable[1 + (i - 1)*2],GossipFrameNpcNameText:GetText());
							end 
							SelectGossipOption(self.GossipIndex);
						end 
					elseif _Questic.GetVariable("RightClickGossipAdd") and Button == "RightButton" and GossipFrameNpcNameText:GetText() and GossipTable[1 + (i - 1)*2] then 
						_Questic.GossipFunctions.ChangeGossip("UserDefined",nil,"ADD",{NPC = GossipFrameNpcNameText:GetText(),Gossip = GossipTable[1 + (i - 1)*2]});
					end 
				end)
				Button:SetPoint("TOP",self,"TOP",0,-Height);
				Button:SetWidth(self:GetWidth() - 2*_Questic.BorderSize);
				Button:Show();
				Height = Height + Button:GetHeight();
			end 
			--Quests 
			if Height > _Questic.BorderSize then --no options added == no height added
				Height = Height + 5; --add gap between quests and gossip
			end 
			
			for i,QuestInfo in ipairs(AvailiableQuests) do 
				local Button = Pool:Acquire("Questic_ADDON_OptionsButtonTemplate");
				local Icon = "Interface\\GossipFrame\\";
				if QuestInfo.Legendary then 
					Icon = Icon.."AvailableLegendaryQuestIcon.blp"
				elseif QuestInfo.Frequency ~= 1 then 
					Icon = Icon.."DailyQuestIcon.blp";
				else 
					Icon = Icon.."AvailableQuestIcon.blp";
				end 
				Button.Text:SetText(string.format("|T%s:0|t",Icon).." "..QuestInfo.Name);	
				Button.Text:SetJustifyH("LEFT");
				Button.GossipIndex = QuestInfo.Index;
				Button.NPCType = QuestInfo.Type;
				Button:SetScript("OnClick",function(self)
					_Questic.SelectQuest(self.GossipIndex,"Available",self.NPCType)
				end)
				Button:SetPoint("TOP",self,"TOP",0,-Height);
				Button:SetWidth(self:GetWidth() - 2*_Questic.BorderSize);
				Button:Show();
				Height = Height + Button:GetHeight();				
			end
			
			if Height > _Questic.BorderSize then --no options added == no height added
				Height = Height + 5; --add gap between quests and gossip
			end 
			
			for i,QuestInfo in ipairs(ActiveQuests) do 
				local Button = Pool:Acquire("Questic_ADDON_OptionsButtonTemplate");
				local Icon = "Interface\\GossipFrame\\";
				if QuestInfo.Complete then 
					Icon = Icon.."ActiveQuestIcon.blp";
				else 
					Icon = Icon.."IncompleteQuestIcon.blp";
				end 
				Button.Text:SetText(string.format("|T%s:0|t",Icon).." "..QuestInfo.Name);	
				Button.Text:SetJustifyH("LEFT");
				Button.GossipIndex = QuestInfo.Index;
				Button.NPCType = QuestInfo.Type;
				Button:SetScript("OnClick",function(self)
					_Questic.SelectQuest(self.GossipIndex,"Active",self.NPCType)
				end)
				Button:SetPoint("TOP",self,"TOP",0,-Height);
				Button:SetWidth(self:GetWidth() - 2*_Questic.BorderSize);
				Button:Show();
				Height = Height + Button:GetHeight();			
			end	
			
			--No options 
			if Height == _Questic.BorderSize then --no options added == no height added
				local Button = Pool:Acquire("Questic_ADDON_OptionsButtonTemplate");
				Button.Text:SetText(string.format("|TInterface\\RAIDFRAME\\ReadyCheck-NotReady.blp:0|t").." No gossip options or quests available");	
				Button.Text:SetJustifyH("LEFT");
				Button:SetScript("OnClick",function(self)
					CloseGossip()
					if Questic_ADDON_GossipQuickSelectFrame:IsShown() then 
						Questic_ADDON_GossipQuickSelectFrame:Hide();
					end 
				end)
				Button:SetPoint("TOP",self,"TOP",0,-Height);
				Button:SetWidth(self:GetWidth() - 2*_Questic.BorderSize);
				Button:Show();
				Height = Height + Button:GetHeight();			
			end 

			--Close 
			local Button = Pool:Acquire("Questic_ADDON_OptionsButtonTemplate");
			Button.Text:SetText(string.format("|TInterface\\RAIDFRAME\\ReadyCheck-NotReady.blp:0|t").." Close");	
			Button.Text:SetJustifyH("LEFT");
			Button:SetScript("OnClick",function(self)
				CloseGossip()
				if Questic_ADDON_GossipQuickSelectFrame:IsShown() then 
					Questic_ADDON_GossipQuickSelectFrame:Hide();
				end 
			end)
			Height = Height + 5; --for a gap 
			Button:SetPoint("TOP",self,"TOP",0,-Height);
			Button:SetWidth(self:GetWidth() - 2*_Questic.BorderSize);
			Button:Show();
			Height = Height + Button:GetHeight();
			
			
			Height = Height + _Questic.BorderSize;
			
			self:SetHeight(Height);
			--self:SetScale(_Questic.GetVariable("GossipQuickSelectScale"));
			self:Show();
		else 
			self.ActiveGossip = false; 
			self:Hide();
		end 
	else 
		self.ActiveGossip = false; 
		self:Hide();
	end 
end 

local function UpdateParameters(self,Force)
	local _,_,_,x,y = self:GetPoint(1);
	if Force or not x or not y then 
		x,y = GetCursorPosition();
		x = x/UIParent:GetEffectiveScale();
		y = y/UIParent:GetEffectiveScale();
	else 
		local PrevScale = self:GetScale();
		x = (x - 10)*PrevScale;
		y = (y + 10)*PrevScale;
	end 
	local NewScale = _Questic.GetVariable("GossipQuickSelectScale");
	self:SetScale(NewScale);
	self:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",x/NewScale + 10,y/NewScale - 10);
end 

_Questic_ADDON_Globals.GossipQuickSelectFrame_OnLoad = function(self)
	_Questic_ADDON_Globals.SetBackdrop(self);
	Pool:CreatePool("BUTTON",self,"Questic_ADDON_OptionsButtonTemplate");
	self.UpdateGossip = UpdateGossip;
	self.UpdateParameters = UpdateParameters;
end


