local _Questic = _Questic_ADDON_Globals;

_Questic.MinimapIcon_OnLoad = function(self)
	self:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
	self:RegisterForDrag("LeftButton");
	self.Border:SetRotation(-1.57079632679);
end 

_Questic.MinimapIcon_DragStop = function(self)     
	self:SetScript("OnUpdate",nil);
    local _,_,_,x,y = self:GetPoint(1);
    _Questic.SaveVariable("MinimapIconPositionx",x);
    _Questic.SaveVariable("MinimapIconPositiony",y);
end 

_Questic.MinimapIcon_DragStart = function(self) 
	if not self.isLocked then
		self:SetScript("OnUpdate",function(self)
			local MapX, MapY = Minimap:GetCenter();
			local MouseX, MouseY = GetCursorPosition();
			local MapScale = Minimap:GetEffectiveScale();
			MapX = MapX*MapScale;
			MapY = MapY*MapScale;
			local Ang = atan2(MouseY - MapY, MouseX - MapX);
			PosX = 80*cos(Ang);
			PosY = 80*sin(Ang);
			self:SetPoint("CENTER", PosX, PosY);
		end)
	end
end 

local function BuildQuickShareTable()
	local QuestTable = _Questic.GetQuestLogTable();
	local Table = {};
	for i,v in pairs(QuestTable) do 
		if v.Type == "NQ" and v.Pushable == "1" then 
			local Item = {Type = "DB_BL", Text = v.Name, Alignment = "LEFT",
			Func = function(self,...) _Questic.ShareQuest(nil,i) end}
			
			table.insert(Table,Item);
		end 
	end 
	table.insert(Table,{Type = "DB_BL",Text = "Close", Func = function(self,...) Questic_ADDON_OptionsDropDownMenu:SetOptions(nil,"QuesticQuickShareKey"); end});
	return Table; 
end 

local MinimapDropDownAnchorPoint = {Point = "TOPRIGHT",Ref = self,RefPoint = "CENTER",X = -8,Y = -8};

_Questic.CreateQuickShareMenu = function(Refresh)
	if Refresh and Questic_ADDON_OptionsDropDownMenu.Key ~= "QuesticQuickShareKey" then return nil end; 
	local QuickShareTable = BuildQuickShareTable();
	local IsShown = false;
	if Refresh then 
		IsShown = Questic_ADDON_OptionsDropDownMenu:RefreshOptions(QuickShareTable,"QuesticQuickShareKey",{Point = "TOPRIGHT",Ref = Questic_ADDON_MinimapIcon,RefPoint = "CENTER",X = -8,Y = -8});
	else 
		IsShown = Questic_ADDON_OptionsDropDownMenu:SetOptions(QuickShareTable,"QuesticQuickShareKey",{Point = "TOPRIGHT",Ref = Questic_ADDON_MinimapIcon,RefPoint = "CENTER",X = -8,Y = -8});
	end 
	return IsShown;
end 

_Questic.MinimapIcon_OnMouseUp = function(self,button) 
	local IsShown = false;
	if button == "RightButton" then 
		--IsShown = Questic_ADDON_OptionsDropDownMenu:SetOptions(nil,nil,{Point = "TOPRIGHT",Ref = self,RefPoint = "CENTER",X = -8,Y = -8});
		Questic_ADDON_OptionsMenu:Call();
	else 
		IsShown = _Questic.CreateQuickShareMenu();
	end 	
	if IsShown then 
		Questic_Tooltip:Hide();
	else   
		Questic_Tooltip:SetOwner(self,"RIGHT_ANCHOR",8,-8);
		Questic_Tooltip:SetText("Questic\n|cFFFFFFFFLeft-Click: Quick share\nRight-Click: Quick options");
	end
end 