_Questic_ADDON_Globals = CreateFrame("FRAME")
local _Questic = _Questic_ADDON_Globals;
local SavedDataLoaded = false;
local LockSV = false; 

local GlobalsDefault = {
	GossipAutoSelectList = {},
	GossipAutoSelectDisabledPresets = {},
	GossipAutoSelectBlackList = {},
	QuestItemBlackList = {},
}

local DefaultCharaTable = {
	SelectedProfile = "Default", 

}

local Centerx,Centery = UIParent:GetCenter(); 
local DefaultProfileTable = {
	MinimapIconPositionx = -12,
	MinimapIconPositiony = -80,
	OptionsMenuPositionx = Centerx,
	OptionsMenuPositiony = 1.5*Centery,
	EnableMinimapIcon = true,
	Enable = true, 
	
	AutoShare = false ,
	
	AutoAccept = true ,
	AutoAcceptNormal = true ,
	AutoAcceptLowLevel = false ,
	AutoAcceptDaily = false ,
	AutoAcceptWeekly = false ,
	AutoAcceptQuestsInBag = true,
	
	AutoTurnin = true ,
	AutoTurninQuestItems = true ,
	AutoTurninNonQuestItems = false,
	AutoturninCurrency = false,
	AutoturninMoney = false,
	
	HideBlizzQuestFrame = true,	
	
	RewardMenuScale = 1,
	RewardMenuPositionx = Centerx,
	RewardMenuPositiony = 1.5*Centery,

	QuestItemBar = true,
	QuestItemBarGrowthDirection = "Right",
	QuestItemBarScale = 1,
	QuestItemBarPositionx = Centerx,
	QuestItemBarPositiony = 1.5*Centery,
	QuestItemBarEnableBlackList = true,
	
	GossipAutoSelect = true, 
	GossipAutoSelectIgnoreSkip = false, 
	GossipAutoSelectPriorSkip = true, 
	GossipAutoSelectSingleOptionGossip = false, 

	GossipQuickSelect = true,
	GossipQuickSelectScale = 1.5,
	IncludeQuestsInGosseipSelect = true,
	HideBlizzGossipFrame = true,
	
	RightClickGossipAdd = true,
	RightClickGossipBlacklistAdd = true,
	
	CinematicSkip = false,
	
	GroupTrackPositionx = Centerx,
	GroupTrackPositiony = 1.5*Centery,
	GroupTrack = false,
	QuestCompareInGroup = true,
	QuestCompareInRaid = true,
	QuestCompareAutoRefresh = true,
	CompareFrequency = 10,
	CompareScale = 1,
	
	SuppressKeys = true,
	AltSuppress = true,
	ShiftSuppress = true,
	CTRLSuppress = true,

}

local function GetSelectedProfile(OverrideSelectedProfile,VarName)
	local CharacterProfile = UnitName("player").."_"..GetRealmName();
	local TableIndex  = "Profiles";
	local ProfileIndex = "Default";
	
	if _G[_Questic_ADDON_Globals.AddonName.."_DB"] and _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharacterProfile] and _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharacterProfile]["SelectedProfile"] then 
		ProfileIndex = _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharacterProfile]["SelectedProfile"];
	end 
	
	ProfileIndex = OverrideSelectedProfile or ProfileIndex or "Default"
	
	if VarName then 
		if GlobalsDefault[VarName] then 
			ProfileIndex = "Globals"
			TableIndex = nil;
		end 	
	end 
	
	return ProfileIndex,TableIndex; 
end 

local RefreshCycle = false; 
local function RefreshAddonFrames(VarName)
	if RefreshCycle then return false; end 
	
	RefreshCycle = true; 
	
	VarName = VarName or "ALL";
	
	--Group track 
	if Questic_ADDON_GroupTrack:IsShown() and (VarName == "ALL" or VarName == "QuestCompareAutoRefresh") then 
		Questic_ADDON_GroupTrack:SetAutoRefreshScript();
	end 
	if VarName == "ALL" or VarName == "QuestCompareInRaid" or VarName == "Enable" or VarName == "GroupTrack" or VarName == "QuestCompareInGroup" then
		Questic_ADDON_GroupTrack:Refresh(true);
	end 
	if VarName == "ALL" or VarName == "GroupTrackPositiony" or VarName == "GroupTrackPositionx" or VarName == "CompareScale" then 
		Questic_ADDON_GroupTrack:UpdateParameters(); 	
	end 
	
	--Hide Blizz frames 
	if VarName == "ALL" or VarName == "Enable" then 
		Questic_ADDON_GroupTrack:UpdateParameters();
		Questic_ADDON_GossipQuickSelectFrame:UpdateGossip();
		Questic_ADDON_ItemSelectMainFrame:Hide(); 
		_Questic_ADDON_Globals.QuestFrameSuppress(true);	
	end 
	if VarName == "ALL" or VarName == "HideBlizzGossipFrame" then 
		_Questic_ADDON_Globals.GossipFrameSuppress(not _Questic.GetVariable("HideBlizzGossipFrame"));	 
	end
	if VarName == "ALL" or VarName == "HideBlizzQuestFrame" then 
		_Questic_ADDON_Globals.QuestFrameSuppress(not _Questic.GetVariable("HideBlizzQuestFrame"));	 
	end
	
	--Gossip auto select 
	if VarName == "ALL" or VarName == "GossipAutoSelectList" then 
		_Questic.GossipFunctions.ChangeGossip("UserDefined");
	end
	if VarName == "ALL" or VarName == "GossipAutoSelectDisabledPresets" then 
		_Questic.GossipFunctions.ChangeGossip("Preset");
	end
	
	
	--Reward select 
	if VarName == "ALL" or VarName == "RewardMenuPositionx" then 
		Questic_ADDON_ItemSelectMainFrame:UpdateParameters(); 
	end
	if VarName == "ALL" or VarName == "RewardMenuPositiony" then 
		Questic_ADDON_ItemSelectMainFrame:UpdateParameters(); 
	end
	
	--Minimap Icon 
	if VarName == "ALL" or VarName == "MinimapIconPositiony" or VarName == "MinimapIconPositionx" then 
		Questic_ADDON_MinimapIcon:SetPoint("CENTER", _Questic.GetVariable("MinimapIconPositionx"), _Questic.GetVariable("MinimapIconPositiony"));
	end
	if VarName == "ALL" or VarName == "EnableMinimapIcon" then 
		if _Questic.GetVariable("EnableMinimapIcon") then 
			Questic_ADDON_MinimapIcon:Show();
		else 
			Questic_ADDON_MinimapIcon:Hide();
		end 	
	end 
	
	--Options Menu Position 
	if VarName == "ALL" or VarName == "OptionsMenuPositionx" or VarName == "OptionsMenuPositiony" then 
		Questic_ADDON_OptionsMenu:UpdatePosition();
	end
	
	--QuestItemBar
	if VarName == "ALL" or VarName == "QuestItemBarPositionx" or VarName == "QuestItemBarPositiony" or VarName == "QuestItemBarScale" then
		Questic_ADDON_UseQuestItemBar:UpdateParameters(); 
	end
	if VarName == "ALL" or VarName == "QuestItemBarGrowthDirection" then
		Questic_ADDON_UseQuestItemBar:Refresh();
		if Questic_ADDON_UseQuestItemBar.PreviewItem:IsShown() then 
			Questic_ADDON_UseQuestItemBar:Movable(true);
		end 
	end
	if VarName == "ALL" or VarName == "Enable" or VarName == "QuestItemBar" or VarName == "QuestItemBarEnableBlackList" or VarName == "QuestItemBlackList" then 
		Questic_ADDON_UseQuestItemBar:Refresh(); 
	end

	--options elements
	Questic_ADDON_OptionsMenu:Refresh();
	
	RefreshCycle = false; 
end 
_Questic.RefreshAddonFrames = RefreshAddonFrames;

local function LoadSV()
	LockSV = true; 
	local CharaIndex = UnitName("player").."_"..GetRealmName()
	
	--create options table 
	if _G[_Questic_ADDON_Globals.AddonName.."_DB"] then 
	
	else 
		_G[_Questic_ADDON_Globals.AddonName.."_DB"] = {}; 
	end 
	
	--character table
	if _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters then 
		if type(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharaIndex]) == "nil" then 
			_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharaIndex] = {};
		end 	
	else 
		_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters = {};
		_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharaIndex] = {};
	end 
	
	_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharaIndex]["SelectedProfile"] = _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharaIndex]["SelectedProfile"] or "Default"
	
	local SelectedProfile = _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[CharaIndex]["SelectedProfile"];
	
	--profiles table 
	if _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles then 
		if type(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[SelectedProfile]) == "nil" then 
			_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[SelectedProfile] = {};
		end 
	else 
		_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles = {};
		_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[SelectedProfile] = {};
	end 
	
	_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles.Default = _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles.Default or {};
	
	--Global table
	_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"] = _G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"] or {};
	if type(_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"]) == "nil" then 
		_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"] = GlobalsDefault
	else 
		for i,v in pairs(GlobalsDefault) do 
			if type(_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"][i]) == "nil" then 
				_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"][i] = v
			end 
		end 
	end 
	
	
	
	if not SavedDataLoaded then --first load reorganize data 
		for i,v in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"]) do 
			if i ~= "Globals" and i ~= "Characters" and i ~= "Profiles" then 
				if v.GossipAutoSelectList then 
					for	_,GossipData in ipairs(v.GossipAutoSelectList) do 
						if type(GossipData.Gossip) == "string" and type(GossipData.NPC) == "string" then 
							local InTable = false; 
							for _,ExistingGossipData in ipairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"]["GossipAutoSelectList"]) do 
								if GossipData.Gossip == ExistingGossipData.Gossip and GossipData.NPC == ExistingGossipData.NPC then 
									InTable = true;
									break; 
								end 
							end 
							if not InTable then 
								table.insert(_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"]["GossipAutoSelectList"],{
									Gossip = GossipData.Gossip, 
									NPC = GossipData.NPC, 
									Note = GossipData.Note,
									Disable = GossipData.Disable
								});
							end 
						end 
					end 
					v.GossipAutoSelectList = nil; 
				end 
				if v.GossipAutoSelectDisabledPresets then 
					for IndexName,Condition in pairs(v.GossipAutoSelectDisabledPresets) do 
						_G[_Questic_ADDON_Globals.AddonName.."_DB"]["Globals"]["GossipAutoSelectDisabledPresets"][IndexName] = Condition;
					end 
					v.GossipAutoSelectDisabledPresets = nil; 
				end 
				
				_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[i] = _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[i] or {}; 
				_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[i] = _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[i] or {}; 
				for VarName,VarValue in pairs(v) do 
					if VarName ~= "SelectedProfile" then 		
						_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[i][VarName] = VarValue;
					end 
					_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[i]["SelectedProfile"] = i; 
				end 
				_G[_Questic_ADDON_Globals.AddonName.."_DB"][i] = nil; 
			end 
		end 
		for i,v in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles) do 
			if v.GroupTrackPosition and v.GroupTrackPosition.x and v.GroupTrackPosition.y then 
				v.GroupTrackPositionx = v.GroupTrackPosition.x; 
				v.GroupTrackPositiony = v.GroupTrackPosition.y;
				v.GroupTrackPosition = nil; 	
			end 
			if v.QuestItemBarPosition and v.QuestItemBarPosition.x and v.QuestItemBarPosition.y then 
				v.QuestItemBarPositionx = v.QuestItemBarPosition.x; 
				v.QuestItemBarPositiony = v.QuestItemBarPosition.y;
				v.QuestItemBarPosition = nil; 		
			end
			if v.RewardMenuPosition and v.RewardMenuPosition.x and v.RewardMenuPosition.y then 
				v.RewardMenuPositionx = v.RewardMenuPosition.x; 
				v.RewardMenuPositiony = v.RewardMenuPosition.y;
				v.RewardMenuPosition = nil; 		
			end
			if v.OptionsMenuPosition and v.OptionsMenuPosition.x and v.OptionsMenuPosition.y then 
				v.OptionsMenuPositionx = v.OptionsMenuPosition.x; 
				v.OptionsMenuPositiony = v.OptionsMenuPosition.y;
				v.OptionsMenuPosition = nil; 	
			end
			if v.MinimapIconPosition and v.MinimapIconPosition.x and v.MinimapIconPosition.y then 
				v.MinimapIconPositionx = v.MinimapIconPosition.x; 
				v.MinimapIconPositiony = v.MinimapIconPosition.y;
				v.MinimapIconPosition = nil; 	
			end 
		end 
	end 
	
	
	
	--check old character tables 
	for i,v in pairs(DefaultCharaTable) do 
		for CIndex,CharaData in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters) do 
			if type(CharaData[i]) == "nil" then 
				CharaData[i] = v;
			end 
		end 
	end 
	
	for i,v in pairs(DefaultProfileTable) do 
		for PIndex,ProfileData in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles) do 
			if type(ProfileData[i]) == "nil" then 
				ProfileData[i] = v;
			end 
		end 
	end 
	
	
	--load callbacks
	RefreshAddonFrames();
	
	SavedDataLoaded = true;
	LockSV = false; 
end

local AddonLoadFrame = CreateFrame("FRAME")

AddonLoadFrame:SetScript("OnEvent",function(self,Event,...)
	if Event == "ADDON_LOADED" and ... == _Questic_ADDON_Globals.AddonName then 
		LoadSV()
	end 
end)

AddonLoadFrame:RegisterEvent("ADDON_LOADED")

_Questic.ProfileManagement = function(Action,Profile,NewName)
	if Profile == "Default" and (Action == "Rename" or Action == "Delete") then 
		print("Questic: \"Default\" profile cannot be deleted or renamed.")
		return Profile;
	end 
	
	if Action == "GetAll" then 
		local ProfileNameTable = {}
		for i,v in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles) do 
			if i ~= "Default" then 
				table.insert(ProfileNameTable,i);
			end 
		end 
		table.sort(ProfileNameTable, function(a,b) return a < b end);
		table.insert(ProfileNameTable,1,"Default");
		return ProfileNameTable;
	elseif Action == "GetActive" then 
		local SelectedProfile = GetSelectedProfile(nil,"Enable");
		return SelectedProfile
	elseif Action == "CreateNew" then 
		for i = 1,100 do 
			if not _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles["New Profile "..i] then 
				_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles["New Profile "..i] = {}
				if _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles["Default"] then 
					for VarName,DefaultValue in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles["Default"]) do 
						_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles["New Profile "..i][VarName] = DefaultValue;
					end 
				else 
					for VarName,DefaultValue in pairs(DefaultProfileTable) do 
						_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles["New Profile "..i][VarName] = DefaultValue;
					end 
				end 				
				return "New Profile "..i
			end 
		end 
		print("Questic: More then 100 New Profiles rename one to create a new profile.")
	elseif Action == "Rename" and type(Profile) == "string" and type(NewName) == "string" and Profile ~= NewName then 
		if _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[Profile] then  
			if _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[NewName] then 
				print("Questic: Profile with the named \""..NewName.."\" already exists.")
				return Profile
			else 
				_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[NewName] = _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[Profile];
				_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[Profile] = nil; 
				for i,v in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters) do 
					if v.SelectedProfile == Profile then 
						v.SelectedProfile = NewName;
					end 
				end 
				return NewName
			end 
		end 
	elseif Action == "Delete" and type(Profile) == "string" then 
		_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[Profile] = nil;  
		for i,v in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters) do 
			if v.SelectedProfile == Profile then 
				if i == UnitName("player").."_"..GetRealmName() then 
					LockSV = true; 
					v.SelectedProfile = "Default";
					LoadSV();
				else 
					v.SelectedProfile = "Default";
				end 
			end 
		end 
	elseif Action == "Load" and type(Profile) == "string" and _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[Profile] then 
		LockSV = true; 
		local SelectedProfile = GetSelectedProfile(nil,"Enable");
		_G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[UnitName("player").."_"..GetRealmName()].SelectedProfile = Profile;
		LoadSV();
		return Profile
	elseif Action == "Copy" and type(Profile) == "string" and _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[Profile] and type(NewName) == "string" and _G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[NewName] then 
		for i,v in pairs(_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[NewName]) do 
			_G[_Questic_ADDON_Globals.AddonName.."_DB"].Profiles[Profile][i] = v;
		end 
		if _G[_Questic_ADDON_Globals.AddonName.."_DB"].Characters[UnitName("player").."_"..GetRealmName()].SelectedProfile == Profile then 
			LockSV = true; 
			LoadSV();
		end 
	end 
end 


_Questic_ADDON_Globals.SaveVariable = function(VarName,Var,SelectedProfile)
	if LockSV then return nil end; 
	local SelectedTableIndex = "Characters";
	SelectedProfile,SelectedTableIndex = GetSelectedProfile(SelectedProfile,VarName) 

	local PrevVal = nil

	if SelectedTableIndex then 
		if _G[_Questic_ADDON_Globals.AddonName.."_DB"] and _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex] and _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex][SelectedProfile] then 
			PrevVal = _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex][SelectedProfile][VarName]
			_G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex][SelectedProfile][VarName] = Var
		end
	else
		if _G[_Questic_ADDON_Globals.AddonName.."_DB"] and _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedProfile] then 
			PrevVal = _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedProfile][VarName]
			_G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedProfile][VarName] = Var
		end
	end 
	
	if (type(PrevVal) == "number" and _Questic.Round(PrevVal,2) ~= _Questic.Round(Var,2)) or (type(PrevVal) ~= "number" and PrevVal ~= Var) then 
		RefreshAddonFrames(VarName);
	end 
	
	return true 
end 

_Questic_ADDON_Globals.GetVariable = function(VarName,SelectedProfile)
	local SelectedTableIndex = "Characters";
	SelectedProfile,SelectedTableIndex = GetSelectedProfile(SelectedProfile,VarName)
		
	if SelectedTableIndex then 
		if _G[_Questic_ADDON_Globals.AddonName.."_DB"] and _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex] and _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex][SelectedProfile] and type(_G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex][SelectedProfile][VarName]) ~= "nil" then 
			return _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedTableIndex][SelectedProfile][VarName]
		else 
			return nil
		end 
	else 
		if _G[_Questic_ADDON_Globals.AddonName.."_DB"] and  _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedProfile] and type(_G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedProfile][VarName]) ~= "nil" then 
			return _G[_Questic_ADDON_Globals.AddonName.."_DB"][SelectedProfile][VarName]
		else 
			return nil
		end 	
	end 
end

local RemoveIndex = {};
_Questic.RemoveWatchFrame = function(WatchFrame,VarName)
	table.wipe(RemoveIndex);
	if VarName then 
		for i,v in ipairs(WatchFramesTable[VarName]) do 
			if v.Frame == WatchFrame then 
				table.insert(RemoveIndex,i)
			end 
		end 
		for i,v in ipairs(RemoveIndex) do 
			table.remove(WatchFramesTable[VarName],v)
		end 
	else 
		for VarName,VarTable in pairs(WatchFramesTable) do 
			for i,v in ipairs(VarTable) do 
				if v.Frame == WatchFrame then 
					table.insert(RemoveIndex,{VarName = VarName, Index = i})
				end 
			end 
		end 
		for i,v in ipairs(RemoveIndex) do 
			table.remove(WatchFramesTable[v.VarName],v.Index)
		end 
	end 
end 

_Questic.AddWatchFrame = function(WatchFrame,VarName,Type)
	WatchFramesTable[VarName] = WatchFramesTable[VarName] or {};
	table.insert(WatchFramesTable[VarName],{Frame = WatchFrame, Type = Type});
end 
