local _Questic = _Questic_ADDON_Globals; 

_Questic_ADDON_Globals.PartyQuestLog = {};

_Questic.QuestFrameSuppress = function(Show)
	QuestFrameGoodbyeButton:EnableMouse(Show);
	QuestFrameCompleteQuestButton:EnableMouse(Show);
	QuestFrameCloseButton:EnableMouse(Show);
	QuestFrameAcceptButton:EnableMouse(Show);
	QuestFrameDeclineButton:EnableMouse(Show);
	QuestFrame:EnableMouse(Show)
	QuestFrame:SetAlpha(Show and 1 or 0);
end 

_Questic.SelectQuest = function(Index,QuestType,NPCType)
	if QuestType == "Available" then 
		SelectAvailableQuest(Index);
		return SelectGossipAvailableQuest(Index);			
	else 
		SelectGossipActiveQuest(Index); 
		return SelectActiveQuest(Index); 
	end 
end 

_Questic.FetchOfferedQuests = function()
	local ActiveQuestTable = {};
	local AvailableQuestTable = {};
	local ActiveGossipQuests = {GetGossipActiveQuests()};
	--title, level, isLowLevel, isComplete, isLegendary, isIgnored
	for i = 1,GetNumGossipActiveQuests() do 
		local title = ActiveGossipQuests[1 + 6*(i - 1)];
		local isComplete = ActiveGossipQuests[4 + 6*(i - 1)];
		table.insert(ActiveQuestTable,{Index = i,Name = title,Complete = isComplete, Type = "Gossip"});
	end 
	local AvailableGossipQuests = {GetGossipAvailableQuests()};
	--title, level, isTrivial, frequency, isRepeatable, isLegendary, isIgnored
	for i = 1,GetNumGossipAvailableQuests() do 
		local title = AvailableGossipQuests[1 + 7*(i - 1)];
		local isTrivial = AvailableGossipQuests[3 + 7*(i - 1)];
		local frequency = AvailableGossipQuests[4 + 7*(i - 1)];
		local isLegendary = AvailableGossipQuests[6 + 7*(i - 1)];
		table.insert(AvailableQuestTable,{Index = i,Name = title,Frequency = frequency,Trivial = isTrivial,Legendary = isLegendary, Type = "Gossip"});
	end 
	for i = 1,GetNumActiveQuests() do 
		local title,isComplete = GetActiveTitle(i);
		table.insert(ActiveQuestTable,{Index = i,Name = title,Complete = isComplete, Type = "Greeting"});
	end 
	for i = 1,GetNumAvailableQuests() do 
		local isTrivial, frequency, isRepeatable, isLegendary = GetAvailableQuestInfo(i);
		local title = GetAvailableTitle(i);
		table.insert(AvailableQuestTable,{Index = i,Name = title,Frequency = frequency,Trivial = isTrivial,Legendary = isLegendary, Type = "Greeting"});
	end 	
	return ActiveQuestTable,AvailableQuestTable;
end


local ToIgnoreTags = {
	128, --Emissary
	140, --Weekly rated award
};

local function QuestDisplayChecker(QuestIndex) 
	if not GetQuestLogTitle(QuestIndex) then --nil
		return false;
	end  
	local QuestTag,_,WQ = GetQuestTagInfo(select(8,GetQuestLogTitle(QuestIndex)));
	if type(QuestTag) == "nil" then 
		return true; 
	elseif WQ then 
		return false;
	else
		for i,v in pairs(ToIgnoreTags) do 
			if v == QuestTag then 
				return false;
			end 
		end 
		return true;
	end 
end

_Questic.ShareQuest = function(QuestIndex,QuestID)
	if QuestID and not QuestIndex then 
		QuestIndex = GetQuestLogIndexByID(QuestID);
	end 
	if QuestDisplayChecker(QuestIndex) then 
		SelectQuestLogEntry(QuestIndex)
		if GetQuestLogPushable() then 
			QuestLogPushQuest();
		end 
	end 
end 


_Questic.GetQuestLogTable = function()
	local QuestTable = {};
	local LastHeaderIndex = 0;
	local HeaderID = "Misc";
	for i = 1,GetNumQuestLogEntries() do 
		local Name,level,isGroupQ,isHeader,_,_,_,questID = GetQuestLogTitle(i);
		local QuestTag,_,WQ = GetQuestTagInfo(select(8,GetQuestLogTitle(i)));
		local Pushable = "0";
		SelectQuestLogEntry(i);
		if GetQuestLogPushable() then 
			Pushable = "1";
		end 
		if isHeader then 
			QuestTable[Name] = {Name = Name, Type = "H",QuestIndex = i,Pushable = Pushable, HeaderID = ""};
			HeaderID = Name;
		elseif QuestDisplayChecker(i) then 
			QuestTable[questID] = {Name = Name, Type = "NQ",QuestIndex = i,Pushable = Pushable, HeaderID = HeaderID};
		else 
			QuestTable[questID] = {Name = Name, Type = "Q",QuestIndex = i,Pushable = Pushable, HeaderID = HeaderID};
		end 
	end 
	return QuestTable;
end 

local UsedList = {};
_Questic.QuestItemList = {};
local RemoveIndex = {};
_Questic.BagScan = function(BagID)	
	table.wipe(_Questic.QuestItemList);
	for BagID = 0,4 do 
		for SlotID = 1,GetContainerNumSlots(BagID) do 
			local QuestItem,QuestID,Accepted = GetContainerItemQuestInfo(BagID,SlotID);
			if QuestItem and GetItemSpell(select(7,GetContainerItemInfo(BagID,SlotID))) then 
				table.insert(_Questic.QuestItemList,{SlotID = SlotID, BagID = BagID});
			elseif QuestID and not UsedList[QuestID] and _Questic.GetVariable("Enable") and _Questic.GetVariable("AutoAccept") and _Questic.GetVariable("AutoAcceptQuestsInBag") and not Accepted and not IsQuestFlaggedCompleted(QuestID) then 
				if _Questic.GetVariable("AutoAcceptQuestsInBag") and _Questic.GetVariable("AutoAccept") then 
					UseContainerItem(BagID,SlotID);
					UsedList[QuestID] = true; 
				end 
			end 
		end 
	end 
end

_Questic.QuestItemBlackList = function(Action,ItemName)
	if Action == "Check" then 
		if _Questic.GetVariable("QuestItemBarEnableBlackList") then 
			if type(ItemName) == "string" then 
				local BlackList = _Questic.GetVariable("QuestItemBlackList");
				if BlackList[ItemName] then 
					return true; 
				else 
					return false;
				
				end 
			else 
				return true; 
			end 
		else 
			return false;
		end 
	elseif Action == "Add" and type(ItemName) == "string" and ItemName ~= "" and GetItemInfo(ItemName) then 
		local BlackList = _Questic.GetVariable("QuestItemBlackList");
		if BlackList[ItemName] then 
			_Questic.RefreshAddonFrames("QuestItemBlackList")
			print("Questic: \""..ItemName.."\" already in quest item bar blacklist.")
		else 
			BlackList[ItemName] = true; 
			_Questic.RefreshAddonFrames("QuestItemBlackList")
			print("Questic: \""..ItemName.."\" added to quest item bar blacklist.")
		end 
	elseif Action == "Remove" and type(ItemName) == "string" and ItemName ~= "" then 
		local BlackList = _Questic.GetVariable("QuestItemBlackList");
		BlackList[ItemName] = nil; 
		_Questic.RefreshAddonFrames("QuestItemBlackList")
		print("Questic: \""..ItemName.."\" removed from quest item bar blacklist.")
	end 
end 
