local _Questic = _Questic_ADDON_Globals;

_Questic_ADDON_Globals.AddonName = "Questic"
_Questic_ADDON_Globals.AddonComsPrefix = "Questic"

--_Questic_ADDON_Globals.SV = {};
--_Questic_ADDON_Globals.SV.Enable = false; --Disable until settings are fully loaded

--local OverrideSelectedProfile; 



_Questic_ADDON_Globals.BorderSize = 3;
_Questic_ADDON_Globals.Padding = 2;
local bgFile = "Interface\\AddOns\\Questic\\Media\\BasicBackdropTexture.blp";
local edgeFile = "Interface\\AddOns\\Questic\\Media\\BasicDynamicBorderTexture.blp"
local BackdropColor = {r = 0.1,g = 0.1,b = 0.1,a = 0.9};
local BorderColor = {r = 0,g = 0,b = 0,a = 1};
_Questic_ADDON_Globals.SetBackdrop = function(self,Type,Data,BackAlpha)
	if not Type or Type == "Backdrop" then 
		if not Data or not (Data.bgFile == bgFile and Data.edgeFile == edgeFile) then 
			self:SetBackdrop({
				bgFile =  bgFile,
				edgeFile = edgeFile, 
				tile = true, tileSize = 16, edgeSize = 3*_Questic_ADDON_Globals.BorderSize, 
				insets = { left = 0, right = 0, top = 0, bottom = 0 }
			})
		end 
	end 
	if not Type or Type == "BackdropColor" then 
		if not Data or not (Data.r == BackdropColor.r and Data.b == BackdropColor.b and Data.g == BackdropColor.g and Data.a == BackdropColor.a) then 
			self:SetBackdropColor(BackdropColor.r,BackdropColor.b,BackdropColor.g,BackAlpha or BackdropColor.a);
		end
	end 
	if not Type or Type == "BorderColor" then 
		if not Data or not (Data.r == BorderColor.r and Data.b == BorderColor.b and Data.g == BorderColor.g and Data.a == BorderColor.a) then 
			self:SetBackdropBorderColor(BorderColor.r,BorderColor.b,BorderColor.g,BorderColor.a);
		end 
	end 
end

_Questic_ADDON_Globals.HighlightBorder = function(self,Click,ForceLeave)
	if Click then 
		self:SetScript("OnUpdate",nil);
		self:SetBackdropBorderColor(1,1,1);	
	else 
		self:SetScript("OnUpdate",function(self)
			if MouseIsOver(self) and not ForceLeave then 
				self:SetBackdropBorderColor(0.5,0.5,0.5);
			else 
				self:SetScript("OnUpdate",nil);
				_Questic_ADDON_Globals.SetBackdrop(self,"BorderColor");
			end 
		end)
	end 
end 

local DelayTime = 0.2

local DelayFrame = CreateFrame("FRAME")
DelayFrame:Hide()

local DelayCallBacks = {}

DelayFrame:SetScript("OnUpdate",function(self,elapsed)
	for i,v in ipairs(DelayCallBacks) do 
		if type(v.Time) ~= "nil" then 
			v.Time = v.Time - elapsed
			if v.Time <= 0 then 
				v.Func(v.RefTime)
				v.Time = nil
				table.remove(DelayCallBacks,i)
			end 
		end 
	end 
	if getn(DelayCallBacks) == 0 then 
		self:Hide()
	end 
end)

_Questic_ADDON_Globals.SetDelay = function(Time,CallBackHandler)
	if type(Time) ~= "number" then 
		Time = DelayTime	
	end 
	if type(CallBackHandler) == "function" then 
		table.insert(DelayCallBacks,{Time = Time,RefTime = Time,Func = CallBackHandler})
		DelayFrame:Show()
	end 
end 

--_Questic.GetVariable("SuppressKeys")

local IncData = {};
local LastUpdate = 0; 
local SendCooldown = 1.5; 
_Questic.DataDistribution = function(msg,sender,QuestID)
	if not msg or (msg and not msg:find("END") and not msg:find("START")) then 
		if abs(LastUpdate - GetTime()) <= SendCooldown then return nil end; 
		LastUpdate = GetTime(); 
		if IsInRaid(LE_PARTY_CATEGORY_INSTANCE) or IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or (not IsInRaid() and not IsInGroup()) then 
			return
		end
	end 
	
	if sender then 
		sender = sender:gsub("-"..select(2,UnitFullName("player")),"");
	end 
	
	if type(sender) == "string" and sender == UnitFullName("player") then return nil end; 
	
	if type(msg) ~= "string" then 
		local Channel = "PARTY"; 
		if IsInRaid() then 
			Channel = "RAID"; --not raid by default to avoid lua errors in arena
		end 
		return C_ChatInfo.SendAddonMessageLogged(_Questic_ADDON_Globals.AddonComsPrefix,"UPDATE",Channel); 
	end
	
	if msg == "REQUEST" and QuestID and type(sender) == "string" then 
		local Channel = "PARTY";
		if IsInRaid() then 
			Channel = "RAID"; --not raid by default to avoid lua errors in arena
		end 
		C_ChatInfo.SendAddonMessageLogged(_Questic_ADDON_Globals.AddonComsPrefix,"REQUEST:"..QuestID,Channel);
	elseif msg:find("REQUEST") then 
		local Event,QuestID = strsplit(":",msg);
		if tonumber(QuestID) then 
			_Questic.ShareQuest(nil,tonumber(QuestID));
		end 
	elseif msg == "UPDATE" then  
		local Channel = "WHISPER";
		if IsInRaid() then 
			Channel = "RAID"; --not raid by default to avoid lua errors in arena
		else 
			Channel = "PARTY";
		end 
		
		local QuestTable = _Questic.GetQuestLogTable();
		local SendString = "START";
		for i,v in pairs(QuestTable) do 
			SendString = SendString.."{"..i.."}"..v.Name.."}"..v.Pushable.."}"..v.HeaderID.."}"..v.Type;
		end 
		SendString = SendString.."{END";
		local MaxString = 255;
		if string.len(SendString) <= MaxString then 
			C_ChatInfo.SendAddonMessageLogged(_Questic_ADDON_Globals.AddonComsPrefix,SendString,Channel,sender);
		else 
			local SendStringTable = {};
			local SendSubString = "";
			SendString:gsub(".", function(c)
				SendSubString = SendSubString..c
				if string.len(SendSubString) == MaxString then 
					table.insert(SendStringTable,SendSubString);
					SendSubString = "START{";
				end 
			end)
			table.insert(SendStringTable,SendSubString);
			for i,v in ipairs(SendStringTable) do
				C_ChatInfo.SendAddonMessageLogged(_Questic_ADDON_Globals.AddonComsPrefix,v,Channel,sender);
			end 
		end		
	elseif msg:find("END") then 
		IncData[sender] = IncData[sender] or "";
		IncData[sender] = IncData[sender]..msg; 
		if IncData[sender]:find("START") then 
			local QuestStringTable = {strsplit("{",IncData[sender]:gsub("START{",""):gsub("{END",""),nil)};
			local QuestTable = {};
			for i,v in pairs(QuestStringTable) do 
				local ID,Name,Pushable,HeaderID,Type = strsplit("}",v);
				if tonumber(ID) then 
					QuestTable[tonumber(ID)] = {Name = Name,Pushable = Pushable,HeaderID = HeaderID, Type = Type};
				else 
					QuestTable[ID] = {Name = Name,Pushable = Pushable,HeaderID = HeaderID, Type = Type};
				end 
			end 
			_Questic.PartyQuestLog[sender] = QuestTable;
			IncData[sender] = nil; 
			Questic_ADDON_GroupTrack:Refresh(true)
		else --rerequest string as data was set was incomplete
			IncData[sender] = nil; 
			C_ChatInfo.SendAddonMessageLogged(_Questic_ADDON_Globals.AddonComsPrefix,"UPDATE","WHISPER",sender);
		end 
	elseif msg:find("START") then  
		IncData[sender] = IncData[sender] or "";
		IncData[sender] = IncData[sender]..msg; 		
	end 
end 



_Questic_ADDON_Globals.Round = function(Number,DecimalPlaces)
	if type(Number) ~= "number" then return 0 end 
	if type(DecimalPlaces) ~= "number" then 
		DecimalPlaces = 0
	end 
	Number = Number*10^DecimalPlaces
	if (Number - floor(Number)) >= 0.5 then 
		Number = ceil(Number)
	else 
		Number = floor(Number)
	end 
	return Number/10^DecimalPlaces
end 

local function InternalMoveFunc_OnUpdate(self,elapsed)
	if self.CheckCombatLock and InCombatLockdown() then 
		return _Questic_ADDON_Globals.MoveFrameFunc(self);
	end 
	local MouseX, MouseY = GetCursorPosition();
	local Scale = UIParent:GetEffectiveScale()*self:GetScale();
	MouseX = MouseX/Scale;
	MouseY = MouseY/Scale;
	self:SetPoint(self.PosParameters.Point,self.PosParameters.Ref,self.PosParameters.RefPoint,MouseX + self.PosParameters.xDif,MouseY + self.PosParameters.yDif);
end

_Questic_ADDON_Globals.MoveFrameFunc = function(self,VarName,Start,CheckCombatLock)
	if Start then 
		if CheckCombatLock and InCombatLockdown() then 
			return nil; 
		end 
		self.PosVarName = VarName; 
		self.CheckCombatLock = CheckCombatLock;
		local Point,Ref,RefPoint,x,y = self:GetPoint(1);
		local MouseX, MouseY = GetCursorPosition();
		local Scale = UIParent:GetEffectiveScale()*self:GetScale();
		self.PosParameters = {
			Point = Point,
			Ref = Ref,
			RefPoint = RefPoint,
			xDif = x - MouseX/Scale,
			yDif = y - MouseY/Scale
		};	
		self:ClearAllPoints();
		self:SetScript("OnUpdate",InternalMoveFunc_OnUpdate);
	else 
		self:SetScript("OnUpdate",nil);
		local _,_,_,x,y = self:GetPoint(1);
		if self.PosVarName and _Questic.GetVariable(self.PosVarName.."x") and _Questic.GetVariable(self.PosVarName.."y") then 
			_Questic.SaveVariable(self.PosVarName.."x",x)
			_Questic.SaveVariable(self.PosVarName.."y",y)
		end 
	end 
end

local ScrollBarPool = CreatePoolCollection();
local ListOfFramesToRefresh = {}
_Questic.RefreshOptionsFrames = function(VarName)
	VarName = VarName or "ALL";
	for i,v in ipairs(ListOfFramesToRefresh) do 
		if type(v.UpdateVar) == "function" and (VarName == "ALL" or v.VarName == VarName) then 
			v:UpdateVar();
		end 
	end 
end 

ScrollBarPool:CreatePool("FRAME",UIParent,"Questic_ADDON_ScrollBarTemplate");
local RemoveIndex = 0;
_Questic.ReleaseFunc = function(self,Col)
	Col = Col or 1;
	if self["ScrollBar"..Col] then 
		ScrollBarPool:Release(self["ScrollBar"..Col]); 
		self["ScrollBar"..Col] = nil; 
	end 
	RemoveIndex = 0;
	if self["BuildPool"..Col] and self["ItemNum"..Col] then 
		for i = 1,self["ItemNum"..Col] do 
			for FrameIndex,Frame in ipairs(ListOfFramesToRefresh) do 
				if Frame == self[Col.."Item"..i] then 
					RemoveIndex = FrameIndex;
					Frame.UpdateVar = nil; 
					Frame.VarName = nil; 
					break; 
				end 
			end 
			table.remove(ListOfFramesToRefresh,RemoveIndex);
			if self[Col.."Item"..i].IndentPool then 
				self[Col.."Item"..i].IndentPool:ReleaseAll(); 
			end 
			if self[Col.."Item"..i] and self[Col.."Item"..i].BuildPool then 
				_Questic.ReleaseFunc(self[Col.."Item"..i]);
			end 
		end 
		self["BuildPool"..Col]:ReleaseAll();
		self["ItemNum"..Col] = 0;
	end 
end 

IndentSpace = 12;
_Questic.BuilderFunc = function(self,Table,Col,MaxCol,MaxElements,StartIndex,FixedHeight)
	Col = Col or 1;
	MaxCol = MaxCol or 1; 
	self["ScrollStartIndex"..Col] = StartIndex or 1; 
	MaxElements = MaxElements or #Table
	self.MaxCol = MaxCol;
	
	if self["ScrollStartIndex"..Col] > #Table - MaxElements + 1 then 
		self["ScrollStartIndex"..Col] = #Table - MaxElements + 1;
	end 
	if self["ScrollStartIndex"..Col] < 1 then 
		self["ScrollStartIndex"..Col] = 1; 
	end 
	
	
	if self["BuildPool"..Col] then
		_Questic.ReleaseFunc(self,Col);
	else 
		if not Table then 
			return nil;
		end 
		self["BuildPool"..Col] = CreatePoolCollection();
		self["BuildPool"..Col]:CreatePool("FRAME",self,"Questic_ADDON_OptionsCheckboxTemplate");
		self["BuildPool"..Col]:CreatePool("FRAME",self,"Questic_ADDON_OptionsCatagoryTemplate");
		self["BuildPool"..Col]:CreatePool("BUTTON",self,"Questic_ADDON_OptionsButtonTemplate");
		self["BuildPool"..Col]:CreatePool("FRAME",self,"Questic_ADDON_OptionsNumericSelectTemplate");
		self["BuildPool"..Col]:CreatePool("FRAME",self,"Questic_ADDON_OptionsSectionTamplate");
		self["BuildPool"..Col]:CreatePool("FRAME",self,"Questic_ADDON_OptionsEditBoxTamplate");
		self["BuildPool"..Col]:CreatePool("FRAME",self,"Questic_ADDON_OptionsSelectBoxTamplate");
	end 
	--local Height = _Questic.BorderSize; 
	--if self.Header then 
	--	Height = self.Header:GetHeight();
	--end 
	self:SetScript("OnMouseWheel",nil); 
	local ShowScrollBar = #Table > MaxElements;
	if self["ScrollBar"..Col] and not ShowScrollBar then 
		ScrollBarPool:Release(self["ScrollBar"..Col]); 
		self["ScrollBar"..Col] = nil; 
	elseif ShowScrollBar then 
		if not self["ScrollBar"..Col] then 
			self["ScrollBar"..Col] = ScrollBarPool:Acquire("Questic_ADDON_ScrollBarTemplate");
			self["ScrollBar"..Col]:SetParent(self);
		end 		
		
		self["ScrollBar"..Col]:SetPoint("BOTTOMRIGHT",self,"BOTTOMLEFT",Col*(self:GetWidth() - (MaxCol - 1)*_Questic.Padding)/MaxCol,0);
		if self.Header then 
			self["ScrollBar"..Col]:SetPoint("TOPRIGHT",self.Header,"BOTTOMLEFT",Col*(self:GetWidth() - (MaxCol - 1)*_Questic.Padding)/MaxCol,0);
		else 
			self["ScrollBar"..Col]:SetPoint("TOPRIGHT",self,"TOPLEFT",Col*(self:GetWidth() - (MaxCol - 1)*_Questic.Padding)/MaxCol,0);		
		end 
		
		self["ScrollBar"..Col].OnScroll = function(Value,PrevVal)
			if Value ~= PrevVal then 
				_Questic.ReleaseFunc(self,Col);
				_Questic.BuilderFunc(self,Table,Col,MaxCol,MaxElements,Value);
			end 
		end 
		
		self["ScrollBar"..Col]:SetRange(self["ScrollStartIndex"..Col] or 1,MaxElements,#Table);
		
		self["ScrollBar"..Col]:Show(); 
		
		self:SetScript("OnMouseWheel",function(self,delta)
			self["ScrollBar"..Col]:SetValue(-delta,true);
		end)
	end 
	
	local BuiltElements = 0;
	for i = self["ScrollStartIndex"..Col],self["ScrollStartIndex"..Col] + MaxElements - 1 do 
		if not Table[i] then 
			break; 
		end 
		BuiltElements = BuiltElements + 1; 
		if Table[i].Type == "LB" then 
			self[Col.."Item"..BuiltElements] = self["BuildPool"..Col]:Acquire("Questic_ADDON_OptionsCatagoryTemplate");
			self[Col.."Item"..BuiltElements].Text:SetText(Table[i].Text);
		elseif Table[i].Type == "TB" then 
			self[Col.."Item"..BuiltElements] = self["BuildPool"..Col]:Acquire("Questic_ADDON_OptionsEditBoxTamplate");	
			self[Col.."Item"..BuiltElements].Text:SetText(Table[i].Text);			
			if Table[i].GetValue then 
				self[Col.."Item"..BuiltElements]:SetValue(Table[i].GetValue());
			elseif Table[i].Value then
				self[Col.."Item"..BuiltElements]:SetValue(Table[i].Value);
			end 
			self[Col.."Item"..BuiltElements]:SetLines(Table[i].Lines);		
			self[Col.."Item"..BuiltElements].OnValueChanged	= Table[i].Func;	
			self[Col.."Item"..BuiltElements]:Disable(Table[i].Disable);
		elseif Table[i].Type == "SB" then 
			self[Col.."Item"..BuiltElements] = self["BuildPool"..Col]:Acquire("Questic_ADDON_OptionsSelectBoxTamplate");		
			self[Col.."Item"..BuiltElements].Text:SetText(Table[i].Text);
			if Table[i].VarName then 
				self[Col.."Item"..BuiltElements].VarName = Table[i].VarName;
				self[Col.."Item"..BuiltElements]:SetOptions(Table[i].GetList(),"");	
				self[Col.."Item"..BuiltElements].OnValueChanged = function(self,Value,UserInput)
					if UserInput then 
						_Questic.SaveVariable(self.VarName,Value);
					end 
				end
				self[Col.."Item"..BuiltElements].UpdateVar = function(self)
					self:SetValue(_Questic.GetVariable(self.VarName));
				end 
				table.insert(ListOfFramesToRefresh,self[Col.."Item"..BuiltElements]);
				if type(_Questic.GetVariable(Table[i].VarName)) == "string" then 
					self[Col.."Item"..BuiltElements]:SetValue(_Questic.GetVariable(Table[i].VarName));
				end
			else 
				self[Col.."Item"..BuiltElements]:SetOptions(Table[i].GetList(),Table[i].GetValue());		
				self[Col.."Item"..BuiltElements].OnValueChanged = Table[i].Func;	
			end 
			self[Col.."Item"..BuiltElements]:Disable(Table[i].Disable);
		elseif Table[i].Type == "CB" then 
			self[Col.."Item"..BuiltElements] = self["BuildPool"..Col]:Acquire("Questic_ADDON_OptionsCheckboxTemplate");	
			self[Col.."Item"..BuiltElements].Text:SetText(Table[i].Text);
			self[Col.."Item"..BuiltElements]:SelectHighlight(Table[i].Selected)
			self[Col.."Item"..BuiltElements].OnSelect = Table[i].SelectFunc;
			if Table[i].VarName then 
				self[Col.."Item"..BuiltElements].VarName = Table[i].VarName;
				self[Col.."Item"..BuiltElements].OnChecked = function(self,Value,UserInput)
					if UserInput then 
						_Questic.SaveVariable(self.VarName,Value);
					end 
				end
				self[Col.."Item"..BuiltElements].UpdateVar = function(self)
					self.Checkbox:SetChecked(_Questic.GetVariable(self.VarName));
				end 
				table.insert(ListOfFramesToRefresh,self[Col.."Item"..BuiltElements]);
				if type(_Questic.GetVariable(Table[i].VarName)) == "boolean" then 
					self[Col.."Item"..BuiltElements].Checkbox:SetChecked(_Questic.GetVariable(Table[i].VarName));
				end
			else 
				self[Col.."Item"..BuiltElements].OnChecked = Table[i].Func;
				if Table[i].GetValue then 
					self[Col.."Item"..BuiltElements].Checkbox:SetChecked(Table[i].GetValue());
				elseif type(Table[i].Value) == "boolean" then 
					self[Col.."Item"..BuiltElements].Checkbox:SetChecked(Table[i].Value);
				end 
			end 
			self[Col.."Item"..BuiltElements]:Disable(Table[i].Disable);
		elseif Table[i].Type == "CBS" then 
			self[Col.."Item"..BuiltElements] = self["BuildPool"..Col]:Acquire("Questic_ADDON_OptionsSectionTamplate");
			self[Col.."Item"..BuiltElements]:AddItems(Table[i].SubElements,Table[i].Text.."Key",Table[i].MaxItems);
			self[Col.."Item"..BuiltElements].Header.Text:SetText(Table[i].Text);	
			if Table[i].VarName then 
				self[Col.."Item"..BuiltElements].Header.VarName = Table[i].VarName;
				self[Col.."Item"..BuiltElements].Header.OnChecked = function(self,Value,UserInput)
					if UserInput then 
						_Questic.SaveVariable(self.Header.VarName,Value);
					end 
				end
				self[Col.."Item"..BuiltElements].UpdateVar = function(self)
					self:SetValue(_Questic.GetVariable(self.VarName));
				end 
				table.insert(ListOfFramesToRefresh,self[Col.."Item"..BuiltElements]);
				if type(_Questic.GetVariable(Table[i].VarName)) == "boolean" then 
					self[Col.."Item"..BuiltElements].Header.Checkbox:SetChecked(_Questic.GetVariable(Table[i].VarName));
				end
				self[Col.."Item"..BuiltElements].Header.Checkbox:Show();
				self[Col.."Item"..BuiltElements].Header.Checkbox:SetWidth(self[Col.."Item"..BuiltElements].Header.Checkbox:GetHeight());  
			elseif Table[i].NoCheckBox then 
				self[Col.."Item"..BuiltElements].Header.Checkbox:Hide(); 
				self[Col.."Item"..BuiltElements].Header.Checkbox:SetWidth(0.1); 
				self[Col.."Item"..BuiltElements].Header.Checkbox:SetChecked(Table[i].Extended);
			end 
			if Table[i].Func then 
				self[Col.."Item"..BuiltElements].Header.OnChecked = Table[i].Func;
			end 
		elseif Table[i].Type == "NB" then 
			self[Col.."Item"..BuiltElements] = self["BuildPool"..Col]:Acquire("Questic_ADDON_OptionsNumericSelectTemplate");
			self[Col.."Item"..BuiltElements].VarName = Table[i].VarName;
			self[Col.."Item"..BuiltElements].Func = Table[i].Func;
			self[Col.."Item"..BuiltElements].Title:SetText(Table[i].Text);
			self[Col.."Item"..BuiltElements]:SetMinMaxStep(Table[i].Min,Table[i].Max,Table[i].Step);
			self[Col.."Item"..BuiltElements].OnValueChanged = function(self,Value,PrevValue,UserInput)
				if self.VarName and UserInput then 
					_Questic.SaveVariable(self.VarName,Value);
				end 
				if self.Func then 
					self.Func();
				end 
			end
			if Table[i].VarName then 
				self[Col.."Item"..BuiltElements].UpdateVar = function(self)
					self:SetValue(_Questic.GetVariable(self.VarName));
				end 
				table.insert(ListOfFramesToRefresh,self[Col.."Item"..BuiltElements]);
				if type(_Questic.GetVariable(Table[i].VarName)) == "number" then 
					self[Col.."Item"..BuiltElements]:SetValue(_Questic.GetVariable(Table[i].VarName));
				end
			end 
		elseif Table[i].Type == "DB" or Table[i].Type == "DB_BL" then 
			self[Col.."Item"..BuiltElements] = self["BuildPool"..Col]:Acquire("Questic_ADDON_OptionsButtonTemplate");
			self[Col.."Item"..BuiltElements].Text:SetText(Table[i].Text);	
			self[Col.."Item"..BuiltElements].Text:SetJustifyH(Table[i].Alignment or "CENTER");
			self[Col.."Item"..BuiltElements]:SelectHighlight(Table[i].Selected)
			if Table[i].Type == "DB_BL" then 
				self[Col.."Item"..BuiltElements]:AddBorder(false); 
			else 
				self[Col.."Item"..BuiltElements]:AddBorder(true); 				
			end 
			self[Col.."Item"..BuiltElements]:DisableButton(Table[i].Disable);
			self[Col.."Item"..BuiltElements]:SetScript("OnClick",Table[i].Func)
		end 
		if self[Col.."Item"..BuiltElements] then
			self[Col.."Item"..BuiltElements]:Show();
			local Offset = 0;
			if PrevIndent then 
				Offset = self[Col.."Item"..BuiltElements]:GetHeight(); 
			end 
			local Width = (self:GetWidth() - 2*_Questic.BorderSize - 2*_Questic.Padding - (MaxCol - 1)*_Questic.Padding)/MaxCol; 
			if ShowScrollBar then 
				Width = Width - 20;
			end 
			Offset = Offset + IndentSpace*(Table[i].Indent or 0);
			if Table[i].Indent then 
				if not self[Col.."Item"..BuiltElements].IndentPool then 
					self[Col.."Item"..BuiltElements].IndentPool = CreatePoolCollection();
					self[Col.."Item"..BuiltElements].IndentPool:CreatePool("FRAME",self[Col.."Item"..BuiltElements],"Questic_ADDON_OptionsIndentTemplate");
				end 
				if Table[i].Header then
					self[Col.."Item"..BuiltElements.."Expandable"] = self[Col.."Item"..BuiltElements].IndentPool:Acquire("Questic_ADDON_OptionsIndentTemplate");
					self[Col.."Item"..BuiltElements.."Expandable"]:SetSize(self[Col.."Item"..BuiltElements]:GetHeight()/2,self[Col.."Item"..BuiltElements]:GetHeight()/2);
					self[Col.."Item"..BuiltElements.."Expandable"]:SetPoint("RIGHT",self[Col.."Item"..BuiltElements],"LEFT",0,0);
					self[Col.."Item"..BuiltElements.."Expandable"]:SetExpanded(Table[i].Expanded);
					self[Col.."Item"..BuiltElements.."Expandable"]:Show(); 
				end 
			end 
			if (i - 1) >= self["ScrollStartIndex"..Col] and Table[i - 1] then 
				Offset = Offset - IndentSpace*(Table[i - 1].Indent or 0);
			end 
			self[Col.."Item"..BuiltElements]:SetWidth(Width - IndentSpace*(Table[i].Indent or 0));
			if BuiltElements == 1 then 
				Offset = Offset + (Col - 1)*Width + Col*_Questic.Padding;	
				local HeightOffset = _Questic.BorderSize + _Questic.Padding;
				if self.Header then 
					HeightOffset = self.Header:GetHeight() + _Questic.Padding;
				end 
				self[Col.."Item"..BuiltElements]:SetPoint("TOPLEFT",self,"TOPLEFT",_Questic.BorderSize + Offset,-HeightOffset);
			else 
				local yOffset = 0;
				if Table[i].Type == "CBS" or Table[i].Type == "DB" then 
					yOffset = -_Questic.Padding;
					--Height = Height + abs(yOffset);
				end 
				self[Col.."Item"..BuiltElements]:SetPoint("TOPLEFT",self[Col.."Item"..(BuiltElements - 1)],"BOTTOMLEFT",Offset,yOffset);
			end 
			--Height = Height + self[Col.."Item"..BuiltElements]:GetHeight();
			self[Col.."Item"..BuiltElements].Tooltip = Table[i].Tooltip;
			if self.TTAnchor then
				self[Col.."Item"..BuiltElements].TTAnchor = self.TTAnchor;
			else 
				self[Col.."Item"..BuiltElements].TTAnchor = self;
			end 
			if Table[i].Type == "CBS" then --requires a defined width 
				self[Col.."Item"..BuiltElements]:Refresh();
			end 
		end 
	end 
	self["ItemNum"..Col] = BuiltElements;
	if not FixedHeight then 
		self.RedoHeight = true; 
		_Questic.RedoOptionHeight(self);
	end 
end 

local AnimationTime = 0.5;
_Questic.RedoOptionHeight = function(self)
	local MaxHeight = 0;
	for Col = 1,self.MaxCol do 
		if self["ItemNum"..Col] and self[Col.."Item"..self["ItemNum"..Col]] and self:GetTop() and self[Col.."Item"..self["ItemNum"..Col]]:GetBottom() then 
			local Height = self:GetTop() - self[Col.."Item"..self["ItemNum"..Col]]:GetBottom();
			MaxHeight = Height > MaxHeight and Height or MaxHeight;
		end 
	end 
	self:SetHeight(MaxHeight + _Questic.BorderSize + _Questic.Padding);
	if self:GetParent().RedoHeight then 
		_Questic.RedoOptionHeight(self:GetParent());	
	end 
end 

SLASH_QUESTIC1 = "/questic"
SLASH_QUESTIC2 = "/questic opt"
SlashCmdList["QUESTIC"] = function(msg)
	if Questic_ADDON_OptionsMenu then 
		Questic_ADDON_OptionsMenu:Call();
	end 
end 