local _Questic = _Questic_ADDON_Globals;

local function ReworkBackdrop(self)
	_Questic.SetBackdrop(self);
	
	hooksecurefunc(self,"SetBackdrop",function(self,Table)
		_Questic.SetBackdrop(self,"Backdrop",Table);
	end)
	hooksecurefunc(self,"SetBackdropColor",function(self,r,g,b,a)
		_Questic.SetBackdrop(self,"BackdropColor",{r = r,g = g,b = b,a = a});
	end)
	hooksecurefunc(self,"SetBackdropBorderColor",function(self,r,g,b,a)
		_Questic.SetBackdrop(self,"BorderColor",{r = r,g = g,b = b,a = a});
	end)
end

_Questic.QuesticTooltip_OnLoad = function(self)
	GameTooltip_OnLoad(self);
	self.shoppingTooltips = {Questic_ShoppingTooltip1,Questic_ShoppingTooltip2};
	
	ReworkBackdrop(self);
	ReworkBackdrop(Questic_ShoppingTooltip1);
	ReworkBackdrop(Questic_ShoppingTooltip2);
end 

local Vert = false;
local function AdjustCompareAnchors()
	Questic_ShoppingTooltip1:ClearAllPoints();
	Questic_ShoppingTooltip2:ClearAllPoints();
	local _,CompreItem = Questic_Tooltip:GetItem();
	local _,CurrentCompreItem = Questic_ShoppingTooltip1:GetItem();
	local TooltipAnchorType = 1;
	--1 - both current items next to each other (rings, trinkets)
	--2 - offhand item below reward (1 hand weapons reward or offhand weapon when 2h equipt)
	--3 - offhand below current equipt (2 hand weapons reward and 1 hand equipt)
	if CompreItem and CurrentCompreItem then 
		local ItemLocation = select(9,GetItemInfo(CompreItem));
		local CurrentItemLocation = select(9,GetItemInfo(CurrentCompreItem));
		if ItemLocation == "INVTYPE_TRINKET" or ItemLocation == "INVTYPE_FINGER" then 
			TooltipAnchorType = 1;
		elseif ItemLocation:find("2") or ItemLocation:find("RANGED") then 
			TooltipAnchorType = 3; 
		elseif (ItemLocation:find("WEAPON") or ItemLocation:find("HOLDABLE") or ItemLocation:find("OFFHAND") or ItemLocation:find("SHIELD")) 
			and (CurrentItemLocation:find("2") or CurrentItemLocation:find("RANGED")) then 
			TooltipAnchorType = 2;
		end 
	end 
	if Questic_ShoppingTooltip2:IsShown() and Vert then 
		Questic_ShoppingTooltip2:SetPoint("TOPLEFT",Questic_Tooltip,"TOPRIGHT",10,0);
		Questic_ShoppingTooltip1:SetPoint("TOPLEFT",Questic_ShoppingTooltip2,"TOPRIGHT",10,0);
	else 
		Questic_ShoppingTooltip1:SetPoint("TOPLEFT",Questic_Tooltip,"TOPRIGHT",10,0);
		if TooltipAnchorType == 1 then 
			Questic_ShoppingTooltip2:SetPoint("TOPLEFT",Questic_ShoppingTooltip1,"TOPRIGHT",10,0);
			Questic_ShoppingTooltip2.PlusIcon:Hide();
		elseif TooltipAnchorType == 3 then
			Questic_ShoppingTooltip2:SetPoint("TOP",Questic_ShoppingTooltip1,"BOTTOM",0,-10);
			Questic_ShoppingTooltip2.PlusIcon:Show();			
		else 
			Questic_ShoppingTooltip2:SetPoint("TOP",Questic_Tooltip,"BOTTOM",0,-10);
			Questic_ShoppingTooltip2.PlusIcon:Show();
		end 
	end
end

_Questic.QuesticTooltip_OnTooltipItemSet = function(self)
	if not self:IsEquippedItem() then
		GameTooltip_ShowCompareItem(self);
		AdjustCompareAnchors();
		Questic_ShoppingTooltip1.ArrowIcon:SetRotation(1.5707963267948966192313216916398);
	else
		Questic_ShoppingTooltip1:Hide();
		Questic_ShoppingTooltip2:Hide();
	end	
end

_Questic.QuesticTooltip_OnTooltipItemSized = function(self)
	if Questic_ShoppingTooltip1:IsShown() then 
		local yOffset = 17.5
		if Vert then 
			if Questic_ShoppingTooltip2:GetHeight() > Questic_ShoppingTooltip1:GetHeight() then 
				yOffset = Questic_ShoppingTooltip1:GetHeight()/2
			else 
				yOffset = Questic_ShoppingTooltip2:GetHeight()/2
			end 
		else 
			if Questic_Tooltip:GetHeight() > Questic_ShoppingTooltip1:GetHeight() then 
				yOffset = Questic_ShoppingTooltip1:GetHeight()/2
			else 
				yOffset = Questic_Tooltip:GetHeight()/2
			end 
		end 
		yOffset = Questic_ShoppingTooltip1.ArrowIcon:GetHeight()/2 - yOffset
		Questic_ShoppingTooltip1.ArrowIcon:SetPoint("TOP",Questic_ShoppingTooltip1,"TOPLEFT",-5,yOffset)
	end 
	if Questic_ShoppingTooltip2:IsShown() then 
		Questic_ShoppingTooltip2.PlusIcon:ClearAllPoints();
		if Vert then 
			local yOffset2 = 12.5
			if Questic_Tooltip:GetHeight() > Questic_ShoppingTooltip2:GetHeight() then 
				yOffset2 = Questic_ShoppingTooltip2:GetHeight()/2
			else 
				yOffset2 = Questic_Tooltip:GetHeight()/2
			end 
			yOffset2 = Questic_ShoppingTooltip2.PlusIcon:GetHeight()/2 - yOffset2
			Questic_ShoppingTooltip2.PlusIcon:SetPoint("TOP",Questic_ShoppingTooltip2,"TOPLEFT",-5,yOffset2)
		else 
			Questic_ShoppingTooltip2.PlusIcon:SetPoint("CENTER",Questic_ShoppingTooltip2,"TOP",0,5)
		end 
	end 
end

--Hook to cyclecompare to use blizz binding
hooksecurefunc("GameTooltip_CycleSecondaryComparedItem",function(self,...)
	if self and type(self.GetName) == "function" and self:GetName() ~= "Questic_Tooltip" and Questic_Tooltip:IsShown() then 
		GameTooltip_CycleSecondaryComparedItem(Questic_Tooltip);
		AdjustCompareAnchors();
	end 
end)